%% PRELIMINARY ACTIONS

%% Inca data import & read file (Honda test)
INCA_data_file = 'C:\Users\zjfxpw\Documents\TESTS\2017 11 06 - ID58\INCA acquisition\RDE_IT4mod_20171106.dat';
%INCA_data_file =app.INCAfile_pathEditField.Value;
RvEtas   = ha_mdfread(INCA_data_file);
RvRef    = ha_commontimegrid(RvEtas,'f1000ms'); %%interpolation at 1 Hz (it can be changed)
INCAdata = RvRef.Data;

clear RvEtas RvRef

%% Input information (ask to the user)
Input.V_reference_PowerBinning_kmh=66; %km/h
Input.a_reference_PowerBinning_ms2=0.44; %m/s^2
Input.f0_N=72.1; %N
Input.f1_Nkmh=0.523; %N/(km/h)
Input.f2_Nkmh2=0.0287; %N/((km/h)^2)
Input.Test_Mass_kg=1361; %kg
Input.Power_rated_KW=88; %KW
Input.CO2_reference_g=0.5*2466.91; %g (half of WLTC CO2)
Input.CO2_lowspeed_phase_gkm=129.37; %g/km
Input.CO2_highspeed_phase_gkm=92.08; %g/km
Input.CO2_extrahighspeed_phase_gkm=111.15; %g/km
Input.CO2_WLTP_gkm=106.6; %g/km
Input.CO2_WLTP_urban_gkm=115; %g/km
Input.starting_altitude_m=327; %m  %Delphi Altitude
Input.factor_CO2_fuelconsumption_diesel=3.17;
Input.factor_CO2_fuelconsumption_gasoline=3.145;

% Input.V_reference_PowerBinning_kmh=app.V_reference_PBkmhEditField.Value; %km/h
% Input.a_reference_PowerBinning_ms2=app.A_reference_PBms2EditField.Value; %m/s^2
% Input.f0_N=app.f0NEditField.Value; %N
% Input.f1_Nkmh=app.f1NkmhEditField.Value; %N/(km/h)
% Input.f2_Nkmh2=app.f2Nkmh2EditField.Value; %N/((km/h)^2)
% Input.Test_Mass_kg=app.Test_MassKgEditField.Value; %kg
% Input.Power_rated_KW=app.P_ratedkWEditField.Value; %KW
% Input.CO2_reference_g=app.ReferenceCO2gEditField.Value; %g (half of WLTC CO2)
% Input.CO2_lowspeed_phase_gkm=app.CO2_low_speedgkmEditField.Value; %g/km
% Input.CO2_highspeed_phase_gkm=app.CO2_high_speedgkmEditField.Value;%g/km
% Input.CO2_extrahighspeed_phase_gkm=app.CO2_extrahigh_speedgkmEditField.Value; %g/km
% Input.CO2_WLTP_gkm=app.CO2_WLTPgkmEditField.Value; %g/km
% Input.CO2_WLTP_urban_gkm=app.CO2_WLTP_urbangkmEditField.Value; %g/km
% Input.starting_altitude_m=app.StartingaltitudemEditField.Value; %m
% Input.factor_CO2_fuelconsumption_diesel=app.ConversionfactorfuelCO2EditField.Value;
% MAW.choice=app.TypeofvehicleEditField.Value;

%% Open the report file
REPORT= fopen ('C:\Users\zjfxpw\Documents\MATLAB\Script Tesi Trip Validity\report.txt','w');
% REPORT= fopen (app.ReportSavepathEditField.Value,'w');
fprintf (REPORT, 'RDE test REPORT ID 221\r\n'); 
% fprintf (REPORT,app.ReportNameEditField.Value);
fprintf (REPORT,'\r\n');
Savepath = 'C:\Users\zjfxpw\Documents\MATLAB\Script Tesi Trip Validity\Report images\'; 
% Savepath =app.ImagesSavepathEditField.Value ;

%% GENERAL REQUIREMENTS

%% Time validity
fprintf (REPORT,'GENERAL REQUIREMENTS \r\n');
fprintf (REPORT,'\r\n');
if (INCAdata.time (end)>= 5400 && INCAdata.time (end)<= 7200)
    validity=[1];
    fprintf (REPORT,'Time duration = %6.0f s  -\r\n',INCAdata.time (end)); % - is passed
else
    validity=[0];
    fprintf (REPORT,'Time duration = %6.0f s  *\r\n',INCAdata.time (end)); % * is NOT passed
end
% app.TimedurationsEditField.Value=INCAdata.time (end);
%% Calculation of distance & time for each portion
distance.tot(1)=0;
distance.urban(1)=0;
distance.rural(1)=0;
distance.motorway(1)=0;
time.urban(1)=0;
time.rural(1)=0;
time.motorway(1)=0;
time.exceed100(1)=0;
time.exceed145(1)=0; 
time.stop(1)=1; %vehicle's first point < 1 km/h
time.singlestoptime(1)=1;%vehicle's first point < 1 km/h
time.k=1;%vehicle's first point < 1 km/h

for i=2: length(INCAdata.IN_Vehicle_speed)
distance.tot (i) = distance.tot (i-1) + ((INCAdata.IN_Vehicle_speed(i))/3600); %km
    if (INCAdata.IN_Vehicle_speed (i)<=60)
    distance.urban (i) =distance.urban (i-1) + ((INCAdata.IN_Vehicle_speed (i))/3600);%km
    time.urban(i)= time.urban(i-1)+1; %s
    else
    distance.urban (i)=distance.urban (i-1);
    time.urban(i)=time.urban(i-1);
    end
    if (INCAdata.IN_Vehicle_speed (i)<=90 && INCAdata.IN_Vehicle_speed (i)>60)
    distance.rural (i) =distance.rural (i-1) + ((INCAdata.IN_Vehicle_speed (i))/3600); %km
    time.rural(i)= time.rural(i-1)+1; %s
    else
    distance.rural (i)=distance.rural (i-1);
    time.rural(i)=time.rural(i-1);
    end
    if INCAdata.IN_Vehicle_speed (i)>90 
    distance.motorway(i)=distance.motorway (i-1) + ((INCAdata.IN_Vehicle_speed (i))/3600); %km
    time.motorway(i)=time.motorway(i-1)+1;
    else
    distance.motorway(i)=distance.motorway(i-1);
    time.motorway(i)=time.motorway(i-1);
    end
    if INCAdata.IN_Vehicle_speed (i)>100
    time.exceed100(i)=time.exceed100(i-1)+1;
    else
    time.exceed100(i)=time.exceed100(i-1);
    end
    if INCAdata.IN_Vehicle_speed (i)>145
    time.exceed145(i)=time.exceed145(i-1)+1;
    else
    time.exceed145(i)=time.exceed145(i-1);
    end
    if INCAdata.IN_Vehicle_speed (i)<1
    time.stop(i)=time.stop(i-1)+1;
    time.k=time.k+1;
    else
    time.stop(i)=time.stop(i-1);
    time.singlestoptime(i)=time.k; %when a stop period finishes, we save the result and we put the counter to 0
    time.k=0;
     end
end

distance.urbanratio=distance.urban(end)/distance.tot(end);
distance.ruralratio=distance.rural(end)/distance.tot(end);
distance.motorwayratio=distance.motorway(end)/distance.tot(end);
INCAdata.maxspeed=max (INCAdata.IN_Vehicle_speed);
INCAdata.averageurbanspeed=3600*distance.urban(end)/time.urban(end);
time.MAXsinglestoptime=max(time.singlestoptime); %sampling frequency of 1 Hz

INCAdata.limitrural=ones (length(INCAdata.time),1)*60; 
INCAdata.limitmotorway=ones (length(INCAdata.time),1)*90;
fig_name = 'Vehicle Speed';
figure(1)
plot (INCAdata.time,INCAdata.IN_Vehicle_speed ,'b');
hold on
plot (INCAdata.time,INCAdata.limitrural,'g');
hold on
plot (INCAdata.time,INCAdata.limitmotorway,'r');
xlim([0 7200]);
ylim([0 160]);
xlabel('Time [s]','FontSize',10,'FontAngle','italic','FontWeight','bold')
ylabel('Vehicle Speed [km/h]','FontSize',10,'FontAngle','italic','FontWeight','bold')
title('Vehicle Speed','FontSize',12,'FontAngle','italic','FontWeight','bold')
saveas(gcf,strcat(Savepath,fig_name),'fig');

%% Distance check

%First check
if (distance.urban(end)>=16) 
    validity=[validity 1];
    fprintf (REPORT,'Urban distance = %6.3f km  -\r\n',distance.urban(end));
else 
    validity = [validity 0];
    fprintf (REPORT,'Urban distance = %6.3f km  *\r\n',distance.urban(end));
end
if (distance.rural(end)>=16) 
    validity=[validity 1];
    fprintf (REPORT,'Rural distance = %6.3f km  -\r\n',distance.rural(end));
else 
    validity = [validity 0];
    fprintf (REPORT,'Rural distance = %6.3f km  *\r\n',distance.rural(end));
end
if (distance.motorway(end)>=16) 
    validity=[validity 1];
    fprintf (REPORT,'Motorway distance = %6.3f km  -\r\n',distance.motorway(end));
else 
    validity = [validity 0];
    fprintf (REPORT,'Motorway distance = %6.3f km  *\r\n',distance.motorway(end));
end
fprintf (REPORT,'Total distance = %6.3f km  \r\n',distance.tot(end));

%Second check
if ((distance.urbanratio>=0.29) &&  (distance.urbanratio<=0.44))
    validity=[validity 1];
    fprintf (REPORT,'Urban distance ratio = %6.3f%%  -\r\n',distance.urbanratio*100);
else 
    validity = [validity 0];
    fprintf (REPORT,'Urban distance ratio = %6.3f%%  *\r\n',distance.urbanratio*100);
end
if ((distance.ruralratio>=0.23) &&  (distance.ruralratio<=0.43)) 
    validity=[validity 1];
    fprintf (REPORT,'Rural distance ratio = %6.3f%%  -\r\n',distance.ruralratio*100);
else 
    validity = [validity 0];
    fprintf (REPORT,'Rural distance ratio = %6.3f%%  *\r\n',distance.ruralratio*100);
end
if ((distance.motorwayratio>=0.23) &&  (distance.motorwayratio<=0.43))
    validity=[validity 1];
    fprintf (REPORT,'Motorway distance ratio = %6.3f%%  -\r\n',distance.motorwayratio*100);
else 
    validity = [validity 0];
    fprintf (REPORT,'Motorway distance ratio = %6.3f%%  *\r\n',distance.motorwayratio*100);
end

% app.UrbandistancekmEditField.Value=distance.urban(end);
% app.RuraldistancekmEditField.Value=distance.rural(end);
% app.MotorwaydistancekmEditField.Value=distance.motorway(end);
% app.TotaldistancekmEditField.Value=distance.tot(end);
% app.UrbandistanceratioEditField.Value=distance.urbanratio*100;
% app.RuraldistanceratioEditField.Value=distance.ruralratio*100;
% app.MotorwaydistanceratioEditField.Value=distance.motorwayratio*100;
%% Maximum speed check
if (INCAdata.maxspeed >=110) && (INCAdata.maxspeed <= 160)
 validity=[validity 1];
 fprintf (REPORT,'Maximum speed = %6.2f Km/h  -\r\n',INCAdata.maxspeed);
else 
 validity = [validity 0];
 fprintf (REPORT,'Maximum speed = %6.2f Km/h  *\r\n',INCAdata.maxspeed);
end
% app.MaximumspeedkmhEditField.Value=INCAdata.maxspeed;

%% Average urban speed check
if (INCAdata.averageurbanspeed>=15) && (INCAdata.averageurbanspeed<40)
 validity=[validity 1];
 fprintf (REPORT,'Average urban = %6.2f Km/h  -\r\n',INCAdata.averageurbanspeed);
else 
 validity = [validity 0];
 fprintf (REPORT,'Average urban = %6.2f Km/h  *\r\n',INCAdata.averageurbanspeed);
end
% app.AverageurbanspeedkmhEditField.Value=INCAdata.averageurbanspeed;

%% Time with Speed over 100 check
if time.exceed100(end)>300
 validity=[validity 1];
 fprintf (REPORT,'Time over 100 km/h = %6.0f s  -\r\n',time.exceed100(end));
else 
 validity = [validity 0];
 fprintf (REPORT,'Time over 100 km/h = %6.0f s  *\r\n',time.exceed100(end));
end
% app.TimewithSpeedover100sEditField.Value=time.exceed100(end);

%% Time with Speed over 145 check
if time.exceed145(end)<(0.03*time.motorway(end))
 validity=[validity 1];
 fprintf (REPORT,'Time over 145 km/h = %6.0f s  -\r\n',time.exceed145(end));
else 
 validity = [validity 0];
 fprintf (REPORT,'Time over 145 km/h = %6.0f s  *\r\n',time.exceed145(end));
end
% app.TimewithSpeedover145sEditField.Value=time.exceed145(end);

%% Stop time checks

% Total stop time
if (time.stop(end)<(0.3*time.urban(end)) && time.stop(end)>(0.06*time.urban(end)))
 validity=[validity 1];
 fprintf (REPORT,'Total stop time = %6.0f s  -\r\n',time.stop(end));
else 
 validity = [validity 0];
 fprintf (REPORT,'Total stop time = %6.0f s  *\r\n',time.stop(end));
end

% Single stop time
if (time.MAXsinglestoptime<300)
 validity=[validity 1];
 fprintf (REPORT,'Longest Stop Time = %6.0f s  -\r\n',time.MAXsinglestoptime(end));
else 
 validity = [validity 0];
 fprintf (REPORT,'Longest Max Stop Time = %6.0f s  *\r\n',time.MAXsinglestoptime(end));
end
% app.TotalstoptimesEditField.Value=time.stop(end);
% app.SinglemaxstoptimesEditField.Value=time.MAXsinglestoptime(end);

%% Idling & Cold start

%Definition of the time instant for the first ignition of the combustion 
for j=2: length(INCAdata.IN_Vehicle_speed)
if INCAdata.IN_Injection_speed(j)>1 %first value with positive injection speed 
break
end
end

%Calculation of idling (rpm<1000) after first ignition
for i=1:length(INCAdata.IN_Vehicle_speed)
if INCAdata.IN_Engine_cycle_speed(i)>1000  %first value with positive injection speed 
break
end
end 
Coldstart.timeidlingafterfirstignition=i-j;

%Evaluation of cold start condition (duration or coolant temperature?)
for i=j:j+300 %cold start duration MAX= 5 minutes
if INCAdata.IN_Coolant_temperature(i)>=70
break
end
end
Coldstart.endofcoldstart=i;

%Evaluation of cold start parameters (j=begin of cold start; i=end of cold start)
Coldstart.stoptime(j-1)=0; %not cold start
for z=j:i
    if INCAdata.IN_Vehicle_speed(z)<1
    Coldstart.stoptime(z)=Coldstart.stoptime(z-1)+1;
    else
    Coldstart.stoptime(z)=Coldstart.stoptime(z-1);
    end
end 
Coldstart.VehicleSpeed=INCAdata.IN_Vehicle_speed(j:i);
Coldstart.MAXspeed=max(Coldstart.VehicleSpeed);
Coldstart.AVERAGEspeed=mean(Coldstart.VehicleSpeed);
Coldstart.Stopduration=Coldstart.stoptime(end);

% Idling & Cold start checks
fprintf (REPORT,'\r\n');
fprintf (REPORT,'Idling & Cold Start: \r\n');
if (Coldstart.timeidlingafterfirstignition<=15)
 validity=[validity 1];
 fprintf (REPORT,'Idling time after first ignition = %6.0f s  -\r\n',Coldstart.timeidlingafterfirstignition);
else 
 validity = [validity 0];
  fprintf (REPORT,'Idling time after first ignition = %6.0f s  *\r\n',Coldstart.timeidlingafterfirstignition);
end

if (Coldstart.MAXspeed<=60)
 validity=[validity 1];
 fprintf (REPORT,'Max speed during COLD START = %6.3f Km/h  -\r\n',Coldstart.MAXspeed);
else 
 validity = [validity 0];
 fprintf (REPORT,'Max speed during COLD START = %6.3f Km/h  *\r\n',Coldstart.MAXspeed);
end

if ((Coldstart.AVERAGEspeed<=40) && (Coldstart.AVERAGEspeed>=15))
 validity=[validity 1];
 fprintf (REPORT,'Average speed during COLD START = %6.3f Km/h  -\r\n',Coldstart.AVERAGEspeed);
else 
 validity = [validity 0];
 fprintf (REPORT,'Average speed during COLD START = %6.3f Km/h  *\r\n',Coldstart.AVERAGEspeed);
end

if (Coldstart.Stopduration<=90)
 validity=[validity 1];
 fprintf (REPORT,'Stop duration during COLD START = %6.0f s  -\r\n',Coldstart.Stopduration);
else 
 validity = [validity 0];
 fprintf (REPORT,'Stop duration during COLD START = %6.0f s  *\r\n',Coldstart.Stopduration);
end

% app.Idlingafter1stignitionsEditField.Value=Coldstart.timeidlingafterfirstignition;
% app.MaxspeedcoldstartkmhEditField.Value=Coldstart.MAXspeed;
% app.AveragespeedcoldstartkmhEditField.Value=Coldstart.AVERAGEspeed;
% app.StopDurationcoldstartsEditField.Value=Coldstart.Stopduration;
%% BOUNDARY CONDITIONS

fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'BOUNDARY CONDITIONS \r\n');
fprintf (REPORT,'\r\n');

%Altitude measured (from 3d route builder)
Altitude_data_file = 'C:\Users\zjfxpw\Documents\MATLAB\Script Tesi Trip Validity\IT 2017 - 02.xlsx';
Altitude_data_sheet = 'Tabelle1';
Altitude_data_range = 'A3:A6262';
Altitude_data_namerange = 'A1:A1';
Altitude_data_unitrange = 'A2:A2';
Altitude.data = xlsread(Altitude_data_file,Altitude_data_sheet,Altitude_data_range);
[~, ~, Altitude.data_names] = xlsread(Altitude_data_file,Altitude_data_sheet,Altitude_data_namerange);
Altitude.data_names(cellfun(@(x) ~isempty(x) && isnumeric(x) && isnan(x),Altitude.data_names)) = {''};
[~, ~, Altitude.data_unit] = xlsread(Altitude_data_file,Altitude_data_sheet,Altitude_data_unitrange);
Altitude.data_unit(cellfun(@(x) ~isempty(x) && isnumeric(x) && isnan(x),Altitude.data_unit)) = {''};
for i = 1:length(Altitude.data_names)
    Altitude.(Altitude.data_names{i}) = Altitude.data(:,i);
end
clear Altitude_data_sheet Altitude_data_range Altitude_data_namerange Altitude_data_unitrange
INCAdata.altitudemeasured=Altitude.Altitude;

%Altitude calculated (from atmospheric pressure)
%INCAdata.altitudecalculated=INCAdata.altitudemeasured;
INCAdata.p0=((((0.0065*Input.starting_altitude_m)/(INCAdata.IN_Ext_air_temp(1)+273.15))+1)^(5.257))*INCAdata.IN_Atmospheric_pressure(1);
INCAdata.altitudecalculated=((((INCAdata.p0./INCAdata.IN_Atmospheric_pressure).^(1/5.257))-1).*(INCAdata.IN_Ext_air_temp+273.15))/0.0065; %https://physics.stackexchange.com/questions/333475/how-to-calculate-altitude-from-current-temperature-and-pressure
INCAdata.diffAltitudestartend=INCAdata.altitudecalculated(end)-INCAdata.altitudecalculated(1); 
if abs(INCAdata.diffAltitudestartend)<=100  
validity=[validity 1];
fprintf (REPORT,'Difference altitude start - end = %6.1f m  -\r\n',abs(INCAdata.diffAltitudestartend));
else
validity = [validity 0];
fprintf (REPORT,'Difference altitude start - end = %6.1f m  *\r\n',abs(INCAdata.diffAltitudestartend));
end

Boundaries.temperature_flag=0; %flag=0:no problem
Boundaries.extendedconditions=0;
Boundaries.notvalidconditions=0;
Boundaries.MAX_Temperature=max(INCAdata.IN_Ext_air_temp);
Boundaries.MIN_Temperature=min(INCAdata.IN_Ext_air_temp);
Boundaries.MAX_Altitude=max(INCAdata.altitudecalculated);
Boundaries.MIN_Altitude=min(INCAdata.altitudecalculated);

for i=1:length(INCAdata.IN_Ext_air_temp)
if INCAdata.IN_Ext_air_temp_valid(i)==0
Boundaries.temperature_flag=1;
break
end
end

for i=1:length(INCAdata.IN_Ext_air_temp)
if (INCAdata.IN_Ext_air_temp(i)>30 && INCAdata.IN_Ext_air_temp(i)<=35)  || (INCAdata.IN_Ext_air_temp(i)>=-7 && INCAdata.IN_Ext_air_temp(i)<0) || (INCAdata.altitudecalculated(i)> 700 && INCAdata.altitudecalculated(i)<=1300)
Boundaries.extendedconditions=Boundaries.extendedconditions+1;
end
if (INCAdata.IN_Ext_air_temp(i)>35)  || (INCAdata.IN_Ext_air_temp(i)<-7) || (INCAdata.altitudecalculated(i)> 1300)
Boundaries.notvalidconditions=Boundaries.notvalidconditions+1;
end
end

if(Boundaries.extendedconditions==0)&&(Boundaries.notvalidconditions==0)&&(Boundaries.temperature_flag==0)
validity=[validity 1];
fprintf (REPORT,'Temperature range =%6.2f',Boundaries.MIN_Temperature);
fprintf (REPORT, ' -%6.2f degC \r\n',Boundaries.MAX_Temperature');
fprintf (REPORT,'Altitude range =%6.1f',Boundaries.MIN_Altitude);
fprintf (REPORT, ' -%6.1f m \r\n',Boundaries.MAX_Altitude');
fprintf (REPORT,'100 %% in Moderate Temperature Conditions \r\n');
elseif (Boundaries.extendedconditions>0)&&(Boundaries.notvalidconditions==0)&&(Boundaries.temperature_flag==0)
validity = [validity 1];
fprintf (REPORT,'Temperature range =%6.2f',Boundaries.MIN_Temperature);
fprintf (REPORT, ' -%6.2f degC \r\n',Boundaries.MAX_Temperature');
fprintf (REPORT,'Altitude range =%6.1f',Boundaries.MIN_Altitude);
fprintf (REPORT, ' -%6.1f m \r\n',Boundaries.MAX_Altitude');
fprintf (REPORT,' %6.2f %% in Moderate Temperature Conditions \r\n',100-100*Boundaries.extendedconditions/length(INCAdata.IN_Ext_air_temp));
elseif (Boundaries.notvalidconditions>0)&&(Boundaries.temperature_flag==0)
validity = [validity 0];
fprintf (REPORT,'Temperature range =%6.2f',Boundaries.MIN_Temperature);
fprintf (REPORT, ' -%6.2f degC \r\n',Boundaries.MAX_Temperature');
fprintf (REPORT,'Altitude range =%6.1f',Boundaries.MIN_Altitude);
fprintf (REPORT, ' -%6.1f m \r\n',Boundaries.MAX_Altitude');
fprintf (REPORT,'NOT Valid Boundaries Conditions \r\n');
else
fprintf (REPORT,'Problem in temperature sensor  -\r\n');
end

Emissions.NOxppmcorrected=INCAdata.IN_Nox_tailpipe_concentration;
Emissions.NOxppmcorrected(1:600)=(INCAdata.P_T_Nox_concentration_est(1:600).*(1-INCAdata.P_T_Scr_nox_conv_eff_mdl(1:600)).*(1-INCAdata.P_T_Scr2_nox_conv_eff_mdl(1:600))); %replace the first 600s (warm up of NOx sensor) with NOx estimator
Emissions.NOxmass=((INCAdata.ACM_Exh_muffler_flow/1000).*Emissions.NOxppmcorrected)*0.001586; %INCAdata.ACM_Exh_muffler_flow=[g/s];IN_Nox_concentration=[ppm]; 0.001586=density ratio (regulation)

for i=1:length(INCAdata.IN_Ext_air_temp) %step 2
if INCAdata.IN_Ext_air_temp(i)<0 || INCAdata.IN_Ext_air_temp(i)> 30 || INCAdata.altitudecalculated(i)>1300
Emissions.NOxmass(i)=Emissions.NOxmass(i)/1.6;
else
Emissions.NOxmass(i)=Emissions.NOxmass(i);
end
end

% for i=1:length(INCAdata.IN_Ext_air_temp) %step 1
% if INCAdata.IN_Ext_air_temp(i)<3 || INCAdata.IN_Ext_air_temp(i)> 30 || INCAdata.altitudecalculated(i)>1300
% Emissions.NOxmass(i)=Emissions.NOxmass(i)/1.6;
% else
% Emissions.NOxmass(i)=Emissions.NOxmass(i);
% end
% end

% app.DifferencealtitudestartendmEditField.Value=abs(INCAdata.diffAltitudestartend);
% app.TimeinmoderateconditionEditField.Value=100-100*Boundaries.extendedconditions/length(INCAdata.IN_Ext_air_temp);
% app.MinTemperaturedegCEditField.Value=Boundaries.MIN_Temperature;
% app.MaxTemperaturedegCEditField.Value=Boundaries.MAX_Temperature;
% app.MinAltitudemEditField.Value=Boundaries.MIN_Altitude;
% app.MaxAltitudemEditField.Value=Boundaries.MAX_Altitude;

%% CUMULATIVE POSITIVE ELEVATION GAIN

fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'CUMULATIVE POSITIVE ELEVATION GAIN\r\n');
fprintf (REPORT,'\r\n');

%Distance & Time TOTAL & URBAN
CPEG.time=INCAdata.time;
CPEG.vehiclespeed=INCAdata.IN_Vehicle_speed;
CPEG.urbantime=0;
for i=1:length(CPEG.vehiclespeed)
if CPEG.vehiclespeed(i)<=60
CPEG.urbantime=CPEG.urbantime+1;
CPEG.vehiclespeedurban(i)=CPEG.vehiclespeed(i);
else 
CPEG.urbantime=CPEG.urbantime;
CPEG.vehiclespeedurban(i)=0;
end
CPEG.distanceurban(i)=CPEG.vehiclespeedurban(i)/3.6;
end
CPEG.distancecumulatedurban(1)=0;
for i=2:length (CPEG.distanceurban)
CPEG.distancecumulatedurban(i)=CPEG.distancecumulatedurban(i-1)+CPEG.distanceurban(i);
end
CPEG.discretedistanceurban=0:1:CPEG.distancecumulatedurban(end);

%h corr (=CPEG.hcorr) TOTAL
CPEG.altitude=INCAdata.altitudecalculated;
CPEG.hcorr=zeros(length(CPEG.time),1);
CPEG.hcorr(1)=CPEG.altitude(1);
for i=2:length (CPEG.time)
if (abs(CPEG.altitude(i)-CPEG.altitude(i-1)))>(CPEG.vehiclespeed(i)/3.6)*sin(pi/4) %pendenza max di 45
CPEG.hcorr(i)=CPEG.hcorr(i-1);
else
CPEG.hcorr(i)=CPEG.altitude(i);
end
end
for i=1:length (CPEG.time)
CPEG.distance(i)=CPEG.vehiclespeed(i)/3.6;
end
CPEG.distancecumulated=(cumtrapz(CPEG.time,CPEG.distance))';
CPEG.discretedistance=0:1:CPEG.distancecumulated(end);

%h int (=CPEG.discretealtitude) TOTAL
for i=1:length(CPEG.discretedistance)
for k=2:length(CPEG.distancecumulated)
if CPEG.distancecumulated(k)>=CPEG.discretedistance(i)
CPEG.hcorrafter(i)=CPEG.hcorr(k);
CPEG.hcorrbefore(i)=CPEG.hcorr(k-1);
CPEG.cumdistafter(i)=CPEG.distancecumulated(k);
CPEG.cumdistbefore(i)=CPEG.distancecumulated(k-1);
CPEG.discretealtitude(i)=CPEG.hcorrbefore(i)+((CPEG.hcorrafter(i)-CPEG.hcorrbefore(i))*(CPEG.discretedistance(i)-CPEG.cumdistbefore(i))/(CPEG.cumdistafter(i)-CPEG.cumdistbefore(i)));
CPEG.speedafter(i)=CPEG.vehiclespeed(k); %calculate discrete speed for each point (used in urban part)
CPEG.speedbefore(i)=CPEG.vehiclespeed(k-1);
CPEG.discretespeed(i)=CPEG.speedbefore(i)+((CPEG.speedafter(i)-CPEG.speedbefore(i))*(CPEG.discretedistance(i)-CPEG.cumdistbefore(i))/(CPEG.cumdistafter(i)-CPEG.cumdistbefore(i)));
break
end
end
end
CPEG.discretealtitude=CPEG.discretealtitude(2:end);
CPEG.discretedistance=CPEG.discretedistance(2:end);

%I road grade TOTAL
for i=1:length(CPEG.discretealtitude)
if CPEG.discretedistance(i)<=200
CPEG.roadgradefirst(i)=(CPEG.discretealtitude(i+200)-CPEG.discretealtitude(1))/(i+200);
elseif CPEG.discretedistance(i)<CPEG.discretedistance(end-200) && CPEG.discretedistance(i)>200
CPEG.roadgradefirst(i)=(CPEG.discretealtitude(i+200)-CPEG.discretealtitude(i-200))/400; %(i+200) - (i-200)
else
CPEG.roadgradefirst(i)=(CPEG.discretealtitude(end)-CPEG.discretealtitude(i-200))/(CPEG.discretedistance(end)-(i-200));
end
end

%h int sm TOTAL
CPEG.discretealtitudesm(1)=CPEG.discretealtitude(1)+CPEG.roadgradefirst(1);
for i=2:length(CPEG.roadgradefirst)
CPEG.discretealtitudesm(i)=CPEG.discretealtitudesm(i-1)+CPEG.roadgradefirst(i); %1m=1
end

%II road grade TOTAL
for i=1:length(CPEG.discretealtitudesm)
if CPEG.discretedistance(i)<=200
CPEG.roadgradesecond(i)=(CPEG.discretealtitudesm(i+200)-CPEG.discretealtitudesm(1))/(i+200);
elseif CPEG.discretedistance(i)<CPEG.discretedistance(end-200) && CPEG.discretedistance(i)>200
CPEG.roadgradesecond(i)=(CPEG.discretealtitudesm(i+200)-CPEG.discretealtitudesm(i-200))/400; %(i+200) - (i-200)
else
CPEG.roadgradesecond(i)=(CPEG.discretealtitudesm(end)-CPEG.discretealtitudesm(i-200))/(CPEG.discretedistance(end)-(i-200));
end
end

%II road grade URBAN (starting from the second road grade TOTAL and keeping
%only the one with vehicle speed < 1 km/h
for i=1:length(CPEG.discretedistance)
if CPEG.discretespeed(i)<=60
CPEG.roadgradesecondurban(i)=CPEG.roadgradesecond(i);
else
CPEG.roadgradesecondurban(i)=0;
end
end

%Cumulative Positive Elevation Gain TOTAL
CPEG.positiveroadgrades=CPEG.roadgradesecond(CPEG.roadgradesecond>0);
CPEG.integralposroadgrade=sum(CPEG.positiveroadgrades);
CPEG.totaldistance=CPEG.discretedistance(end)/1000; %km
CPEG.cumposelgaintotal=CPEG.integralposroadgrade*100/CPEG.totaldistance; %m/100 km

%Cumulative Positive Elevation Gain URBAN (method 2:RIGHT)
CPEG.positiveroadgradesurban=CPEG.roadgradesecondurban(CPEG.roadgradesecondurban>0);
CPEG.integralposroadgradeurban=sum(CPEG.positiveroadgradesurban);
CPEG.urbandistance=CPEG.discretedistanceurban(end)/1000; %km
CPEG.cumposelgainurban=CPEG.integralposroadgradeurban*100/CPEG.urbandistance; %m/100 km %divided for urban distance

%Report TOTAL
if(CPEG.cumposelgaintotal<1200)
validity=[validity 1];
fprintf (REPORT,'Total Cumulative positive elevation gain = %6.2f m/100km   -\r\n',CPEG.cumposelgaintotal);
else 
validity = [validity 0];
fprintf (REPORT,'Total Cumulative positive elevation gain = %6.2f m/100km   *\r\n',CPEG.cumposelgaintotal);
end  

%Report URBAN
if(CPEG.cumposelgainurban<1200)
validity=[validity 1];
fprintf (REPORT,'Urban Cumulative positive elevation gain = %6.2f m/100km   -\r\n',CPEG.cumposelgainurban);
else 
validity = [validity 0];
fprintf (REPORT,'Urban Cumulative positive elevation gain = %6.2f m/100km   *\r\n',CPEG.cumposelgainurban);
end 

%Draw roadgrade & altitude SM
fig_name = 'Road gradient & Discrete Altitude';
figure(2)
plotyy (CPEG.discretedistance,CPEG.roadgradesecond,CPEG.discretedistance,CPEG.discretealtitudesm);
xlim([0 120000]);
xlabel('Discrete Distance [m]','FontSize',10,'FontAngle','italic','FontWeight','bold')
legend('Road Grade Second','Discrete Altitude sm')
title('Road gradient & Discrete Altitude','FontSize',12,'FontAngle','italic','FontWeight','bold')
saveas(gcf,strcat(Savepath,fig_name),'fig');

% app.TotalCumPosElGainm100kmEditField.Value=CPEG.cumposelgaintotal;
% app.UrbanCumPosElGainm100kmEditField.Value=CPEG.cumposelgainurban;

%% DYNAMICS REQUIREMENTS: v*apos[95] & RPA

fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'VAPOS[95] & RPA \r\n');
fprintf (REPORT,'\r\n');

%Determination of bins
for i=2: (length(INCAdata.IN_Vehicle_speed)-1)
    if (INCAdata.IN_Vehicle_speed(i)<=60)
    dynamics.accelurban (i) =(INCAdata.IN_Vehicle_speed (i+1) - INCAdata.IN_Vehicle_speed (i-1))/(2*3.6);%m/s^2
    dynamics.vaurban(i)=dynamics.accelurban(i)*INCAdata.IN_Vehicle_speed (i)/3.6; %m2/s3
    else
    dynamics.accelurban (i)=0;
    dynamics.vaurban(i)=0;
    end
    if (INCAdata.IN_Vehicle_speed(i)<=90 && INCAdata.IN_Vehicle_speed(i)>60)
    dynamics.accelrural (i) =(INCAdata.IN_Vehicle_speed (i+1) - INCAdata.IN_Vehicle_speed (i-1))/(2*3.6);%m/s^2
    dynamics.varural(i)=dynamics.accelrural(i)*INCAdata.IN_Vehicle_speed(i)/3.6; %m2/s3
    else
    dynamics.accelrural (i)=0;
    dynamics.varural(i)=0;
    end
    if INCAdata.IN_Vehicle_speed(i)>90 
    dynamics.accelmotorway (i) =(INCAdata.IN_Vehicle_speed (i+1) - INCAdata.IN_Vehicle_speed(i-1))/(2*3.6);%m/s^2
    dynamics.vamotorway(i)=dynamics.accelmotorway(i)*INCAdata.IN_Vehicle_speed(i)/3.6; %m2/s3
    else
    dynamics.accelmotorway (i)=0;
    dynamics.vamotorway(i)=0;
    end
end
dynamics.averageurbanspeed=3600*distance.urban(end)/time.urban(end);
dynamics.averageruralspeed=3600*distance.rural(end)/time.rural(end);
dynamics.averagemotorwayspeed=3600*distance.motorway(end)/time.motorway(end);
dynamics.urbanbins= length (dynamics.accelurban(dynamics.accelurban>0.1)); %>150
dynamics.ruralbins= length (dynamics.accelrural(dynamics.accelrural>0.1)); %>150
dynamics.motorwaybins= length (dynamics.accelmotorway(dynamics.accelmotorway>0.1)); %>150

%Calculation of vapos[95]
dynamics.vapositiveurban=dynamics.vaurban(dynamics.accelurban>0.1);
dynamics.vapositiverural=dynamics.varural(dynamics.accelrural>0.1);
dynamics.vapositivemotorway=dynamics.vamotorway(dynamics.accelmotorway>0.1);
dynamics.vapositiveurbanordered=sort(dynamics.vapositiveurban);
dynamics.vapositiveruralordered=sort(dynamics.vapositiverural);
dynamics.vapositivemotorwayordered=sort(dynamics.vapositivemotorway);

for u=1:dynamics.urbanbins
    if u/dynamics.urbanbins>=0.95
    break
    end
end
dynamics.va95urban= (u-0.95*dynamics.urbanbins)*(dynamics.vapositiveurbanordered(u-1)-dynamics.vapositiveurbanordered(u)) + dynamics.vapositiveurbanordered(u); %it works also if u=0.95*bins

for r=1:dynamics.ruralbins
    if r/dynamics.ruralbins>=0.95
    break
    end
end
dynamics.va95rural= (r-0.95*dynamics.ruralbins)*(dynamics.vapositiveruralordered(r-1)-dynamics.vapositiveruralordered(r)) + dynamics.vapositiveruralordered(r); %it works also if r=0.95*bins

for m=1:dynamics.motorwaybins
    if m/dynamics.motorwaybins>=0.95
    break
    end
end
dynamics.va95motorway= (m-0.95*dynamics.motorwaybins)*(dynamics.vapositivemotorwayordered(m-1)-dynamics.vapositivemotorwayordered(m)) + dynamics.vapositivemotorwayordered(m); %it works also if m=0.95*bins

%Calculation of RPA
dynamics.RPAurban=sum(dynamics.vapositiveurban)/(1000*distance.urban(end));
dynamics.RPArural=sum(dynamics.vapositiverural)/(1000*distance.rural(end));
dynamics.RPAmotorway=sum(dynamics.vapositivemotorway)/(1000*distance.motorway(end));

%Number of bins check
if dynamics.urbanbins>=150
validity=[validity 1];
fprintf (REPORT,'Urban bins = %6.0f   -\r\n',dynamics.urbanbins);
else 
validity = [validity 0];
fprintf (REPORT,'Urban bins = %6.0f   *\r\n',dynamics.urbanbins);
end

if dynamics.ruralbins>=150
validity=[validity 1];
fprintf (REPORT,'Rural bins = %6.0f   -\r\n',dynamics.ruralbins);
else 
validity = [validity 0];
fprintf (REPORT,'Rural bins = %6.0f   *\r\n',dynamics.ruralbins);
end

if dynamics.motorwaybins>=150
validity=[validity 1];
fprintf (REPORT,'Motorway bins = %6.0f   -\r\n',dynamics.motorwaybins);
else 
validity = [validity 0];
fprintf (REPORT,'Motorway bins = %6.0f   *\r\n',dynamics.motorwaybins);
end

%vapos[95]check
if dynamics.va95urban<0.136*dynamics.averageurbanspeed + 14.44
validity=[validity 1];
fprintf (REPORT,'vapos[95] urban = %6.3f m^2/s^3  -\r\n',dynamics.va95urban);
else 
validity = [validity 0];
fprintf (REPORT,'vapos[95] urban = %6.3f m^2/s^3  *\r\n',dynamics.va95urban);
end

if (dynamics.averageruralspeed<=74.6) && (dynamics.va95rural<0.136*dynamics.averageruralspeed + 14.44)
validity=[validity 1];
fprintf (REPORT,'vapos[95] rural = %6.3f m^2/s^3  -\r\n',dynamics.va95rural);
elseif (dynamics.averageruralspeed>74.6) && (dynamics.va95rural<0.0742*dynamics.averageruralspeed + 18.966)
validity=[validity 1];
fprintf (REPORT,'vapos[95] rural = %6.3f m^2/s^3  -\r\n',dynamics.va95rural);
else
validity = [validity 0];
fprintf (REPORT,'vapos[95] rural = %6.3f m^2/s^3  *\r\n',dynamics.va95rural);
end

if dynamics.va95motorway<0.0742*dynamics.averagemotorwayspeed + 18.966
validity=[validity 1];
fprintf (REPORT,'vapos[95] motorway = %6.3f m^2/s^3  -\r\n',dynamics.va95motorway);
else 
validity = [validity 0];
fprintf (REPORT,'vapos[95] motorway = %6.3f m^2/s^3  *\r\n',dynamics.va95motorway);
end

%RPA check
if dynamics.RPAurban>-0.0016*dynamics.averageurbanspeed + 0.1755
validity=[validity 1];
fprintf (REPORT,'RPA urban = %6.4f m/s^2  -\r\n',dynamics.RPAurban);
else 
validity = [validity 0];
fprintf (REPORT,'RPA urban = %6.4f m/s^2  *\r\n',dynamics.RPAurban);
end

if dynamics.RPArural>-0.0016*dynamics.averageruralspeed + 0.1755
validity=[validity 1];
fprintf (REPORT,'RPA rural = %6.4f m/s^2  -\r\n',dynamics.RPArural);
else 
validity = [validity 0];
fprintf (REPORT,'RPA rural = %6.4f m/s^2  *\r\n',dynamics.RPArural);
end

if (dynamics.averagemotorwayspeed<=94.05) && (dynamics.RPArural>-0.0016*dynamics.averagemotorwayspeed + 0.1755)
validity=[validity 1];
fprintf (REPORT,'RPA motorway = %6.4f m/s^2  -\r\n',dynamics.RPAmotorway);
elseif (dynamics.averagemotorwayspeed>94.05) && (dynamics.RPAmotorway>0.025)
validity=[validity 1];
fprintf (REPORT,'RPA motorway = %6.4f m/s^2  -\r\n',dynamics.RPAmotorway);
else
validity = [validity 0];
fprintf (REPORT,'RPA motorway = %6.4f m/s^2  *\r\n',dynamics.RPAmotorway);
end

%Graphic vapos[95] & RPA
dynamics.graphic_v1=0:0.1:74.6;
dynamics.graphic_v2=74.6:0.1:160;
fig_name = 'vapos [95]';
figure(3)
plot (dynamics.graphic_v1,0.136*dynamics.graphic_v1+14.44,'k');
hold on
plot (dynamics.graphic_v2,0.0742*dynamics.graphic_v2+18.966,'k');
hold on
scatter (dynamics.averageurbanspeed,dynamics.va95urban);
hold on
scatter (dynamics.averageruralspeed,dynamics.va95rural);
hold on
scatter (dynamics.averagemotorwayspeed,dynamics.va95motorway);
xlim([0 180]);
ylim([0 40]);
xlabel('Vehicle Speed [km/h]','FontSize',10,'FontAngle','italic','FontWeight','bold');
ylabel('vapos95 [m^2/s^3]','FontSize',10,'FontAngle','italic','FontWeight','bold');
title('vapos [95]','FontSize',12,'FontAngle','italic','FontWeight','bold');
saveas(gcf,strcat(Savepath,fig_name),'fig');

dynamics.graphic_v3=0:0.1:94.05;
dynamics.graphic_v4=94.05:0.1:160;
fig_name = 'RPA';
figure(4)
plot (dynamics.graphic_v3,((-0.0016*dynamics.graphic_v3)+0.1755),'k');
hold on
plot (dynamics.graphic_v4,0.025*ones(length(dynamics.graphic_v4),1),'k');
hold on
scatter (dynamics.averageurbanspeed,dynamics.RPAurban);
hold on
scatter (dynamics.averageruralspeed,dynamics.RPArural);
hold on
scatter (dynamics.averagemotorwayspeed,dynamics.RPAmotorway);
xlim([0 180]);
ylim([0 0.3]);
xlabel('Vehicle Speed [km/h]','FontSize',10,'FontAngle','italic','FontWeight','bold');
ylabel('RPA [m/s^2]','FontSize',10,'FontAngle','italic','FontWeight','bold');
title('RPA','FontSize',12,'FontAngle','italic','FontWeight','bold');
saveas(gcf,strcat(Savepath,fig_name),'fig');

% app.UrbanbinsEditField.Value=dynamics.urbanbins;
% app.RuralbinsEditField.Value=dynamics.ruralbins;
% app.MotorwaybinsEditField.Value=dynamics.motorwaybins;
% app.vapos95urbanm2s3EditField.Value=dynamics.va95urban;
% app.vapos95ruralm2s3EditField.Value=dynamics.va95rural;
% app.vapos95motorwaym2s3EditField.Value=dynamics.va95motorway;
% app.RPAurbanms2EditField.Value=dynamics.RPAurban;
% app.RPAruralms2EditField.Value=dynamics.RPArural;
% app.RPAmotorwayms2EditField.Value=dynamics.RPAmotorway;

%% POWER BINNING METHOD

%Definition of de-normalised standard power frequency values
PB.vref=Input.V_reference_PowerBinning_kmh;
PB.aref=Input.a_reference_PowerBinning_ms2; 
PB.f0=Input.f0_N; %honda
PB.f1=Input.f1_Nkmh;%honda
PB.f2=Input.f2_Nkmh2;%honda
PB.TM=Input.Test_Mass_kg;%honda
PB.normalised=[-0.1;0.1;1;1.9;2.8;3.7;4.6;5.5]; %given by regulation
PB.Pdrive=(PB.vref/3.6)*(PB.f0+PB.f1*PB.vref+PB.f2*PB.vref*PB.vref+PB.TM*PB.aref)*0.001;
PB.denormalised=PB.normalised*PB.Pdrive;
PB.Prated=Input.Power_rated_KW;
PB.Pmax=0.9*PB.Prated;
PB.Pdrag=-0.04*PB.Prated;

%read WLTC file (excel)
WLTC_data_file = 'C:\Users\zjfxpw\Documents\MATLAB\Script Tesi Trip Validity\LA_170711_004_1Hz.csv';
WLTC_data_sheet = 'LA_170711_004_1Hz';
WLTC_data_range = 'A3:BP1802';
WLTC_data_namerange = 'A1:BP1';
WLTC_data_unitrange = 'A2:BP2';

WLTC.data = xlsread(WLTC_data_file,WLTC_data_sheet,WLTC_data_range);
[~, ~, WLTC.data_names] = xlsread(WLTC_data_file,WLTC_data_sheet,WLTC_data_namerange);
WLTC.data_names(cellfun(@(x) ~isempty(x) && isnumeric(x) && isnan(x),WLTC.data_names)) = {''};
[~, ~, WLTC.data_unit] = xlsread(WLTC_data_file,WLTC_data_sheet,WLTC_data_unitrange);
WLTC.data_unit(cellfun(@(x) ~isempty(x) && isnumeric(x) && isnan(x),WLTC.data_unit)) = {''};

for i = 1:length(WLTC.data_names)
    WLTC.(WLTC.data_names{i}) = WLTC.data(:,i);
end

clear WLTC_data_sheet WLTC_data_range WLTC_data_namerange WLTC_data_unitrange

%Calculation of k & D
PB.WLTC_accel(1) = WLTC.SchedSpeed(1) /3.6;
for i = 2:length(WLTC.SchedSpeed)        
PB.WLTC_accel(i) = (WLTC.SchedSpeed(i)-WLTC.SchedSpeed(i-1))/3.6; %m/s2
end

for i=1: length (WLTC.SchedSpeed)
PB.Pw_WLTC(i)= (WLTC.SchedSpeed(i)*(0.001/3.6))*(PB.f0+(PB.f1*WLTC.SchedSpeed(i))+(PB.f2*(WLTC.SchedSpeed(i))^2)+(PB.TM*PB.WLTC_accel(i)));
if PB.Pw_WLTC(i)<PB.Pdrag
PB.Pw_WLTC(i)=PB.Pdrag;
else
PB.Pw_WLTC(i)=PB.Pw_WLTC(i);
end
end
    
PB.Pw_WLTC_l = sum(PB.Pw_WLTC(1:589)) /589; % [Kw] average power for phase low
PB.Pw_WLTC_m = sum(PB.Pw_WLTC(590:1022)) / 433; % [Kw] average power for phase medium
PB.Pw_WLTC_h = sum(PB.Pw_WLTC(1023:1477)) / 455; % [Kw] average power for phase high
PB.Pw_WLTC_eh = sum(PB.Pw_WLTC(1478:1800)) / 323; % [Kw] average power for phase extra-high
PB.Pw_WLTC_phase = [PB.Pw_WLTC_l;PB.Pw_WLTC_m;PB.Pw_WLTC_h;PB.Pw_WLTC_eh]; % [Kw] Phase average power
PB.WLTC_CO2_gh = WLTC.TCO2M*3600; %[g/h] CO2 mass flow (vector)
PB.CO2_WLTC_l = sum(PB.WLTC_CO2_gh(1:589))/589; % [g/h] average CO2 for phase low
PB.CO2_WLTC_m = sum(PB.WLTC_CO2_gh(590:1022)) / 433; % [g/h] average CO2 for phase medium
PB.CO2_WLTC_h = sum(PB.WLTC_CO2_gh(1023:1477)) / 455; % [g/h] average CO2 for phase high
PB.CO2_WLTC_eh = sum(PB.WLTC_CO2_gh(1478:1800)) / 323; % [g/h] average CO2 for phase extra-high
PB.CO2_WLTC_phase = [PB.CO2_WLTC_l;PB.CO2_WLTC_m;PB.CO2_WLTC_h;PB.CO2_WLTC_eh]; % [g/h] Phase average CO2

PB.p = polyfit(PB.Pw_WLTC_phase,PB.CO2_WLTC_phase,1);
PB.k = PB.p(1);
PB.D = PB.p(2);

%Calculation of Pwheel based on CO2 RDE trip emissions, k & D: TOT
PB.CO2TOT=zeros(length(INCAdata.time),1); %vector of zeros
PB.PwTOT=zeros(length(INCAdata.time),1);
for i=2:length(INCAdata.time) %only available the injection of fuel demanded for next injection no feedback) 
PB.CO2TOT(i)=Input.factor_CO2_fuelconsumption_diesel*INCAdata.FQD_Chkd_inj_fuel_dmnd(i-1)*INCAdata.IN_Engine_cycle_speed(i)*0.12; %g/h %Damien book
if PB.CO2TOT(i)<0
PB.CO2TOT(i)=0;
else
PB.CO2TOT(i)=PB.CO2TOT(i);
end
if INCAdata.IN_Vehicle_speed(i)<=1 && PB.CO2TOT(i)<=PB.D
    PB.PwTOT(i)=0;
elseif INCAdata.IN_Vehicle_speed(i)>1 && PB.CO2TOT(i)<0.5*PB.D
    PB.PwTOT(i)=PB.Pdrag;
else
    PB.PwTOT(i)=(PB.CO2TOT(i)-PB.D)/PB.k; %%Kw
end
end

%check if CO2 values are correct 
PB.CO2_check1=PB.CO2TOT/3600; %g/s
PB.CO2_check2=cumtrapz(INCAdata.time,PB.CO2_check1);%g 
PB.CO2_checkend=PB.CO2_check2(end); %g total: it shall be similar to total CO2 raw emissions (horiba report)

%Pw moving average TOT
for i=1:(length(INCAdata.time)-2) % Last 2 pts - Do they have their own windows?
    PB.Pw_averageTOT(i) = (PB.PwTOT(i)+ PB.PwTOT(i+1)+ PB.PwTOT(i+2)) / 3; % [kW]
end

%Pw_average_bins TOT
PB.TOTcounter_1 = 0;
PB.TOTcounter_2 = 0;
PB.TOTcounter_3 = 0;
PB.TOTcounter_4 = 0;
PB.TOTcounter_5 = 0;
PB.TOTcounter_6 = 0;
PB.TOTcounter_7 = 0;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0;
for i = 1:length(PB.Pw_averageTOT)
if PB.Pw_averageTOT(i) <= PB.denormalised(1)
PB.TOTcounter_1 = PB.TOTcounter_1+1;
elseif PB.Pw_averageTOT(i) > PB.denormalised(1) && PB.Pw_averageTOT(i) <= PB.denormalised(2)
PB.TOTcounter_2 = PB.TOTcounter_2+1;
elseif PB.Pw_averageTOT(i) > PB.denormalised(2)  && PB.Pw_averageTOT(i) <= PB.denormalised(3)
PB.TOTcounter_3 = PB.TOTcounter_3+1;
elseif PB.Pw_averageTOT(i) >PB.denormalised(3)  && PB.Pw_averageTOT(i) <= PB.denormalised(4)
PB.TOTcounter_4 = PB.TOTcounter_4+1;
elseif PB.Pw_averageTOT(i) > PB.denormalised(4) && PB.Pw_averageTOT(i) <= PB.denormalised(5)
PB.TOTcounter_5 = PB.TOTcounter_5+1;
elseif PB.Pw_averageTOT(i) >PB.denormalised(5) && PB.Pw_averageTOT(i) <= PB.denormalised(6)
PB.TOTcounter_6 = PB.TOTcounter_6+1;
elseif PB.Pw_averageTOT(i) >PB.denormalised(6)  && PB.Pw_averageTOT(i) <= PB.denormalised(7)
PB.TOTcounter_7 = PB.TOTcounter_7+1;
elseif PB.Pw_averageTOT(i) > PB.denormalised(7) && PB.Pw_averageTOT(i) <= PB.denormalised(8)
PB.TOTcounter_8 = PB.TOTcounter_8+1;
else 
PB.TOTcounter_9 = PB.TOTcounter_9+1;
end   
end

%PwMAX detection (all excluded Pw added to the highest remaining class) TOT
if PB.Pmax <= PB.denormalised(1)
PB.TOTClmax = 1; %class which contains Pmax
PB.TOTcounter_1 = PB.TOTcounter_1 + PB.TOTcounter_2 + PB.TOTcounter_3 + PB.TOTcounter_4 + PB.TOTcounter_5 + PB.TOTcounter_6 + PB.TOTcounter_7 + PB.TOTcounter_8 + PB.TOTcounter_9; %put the remaining in the higher class
PB.TOTcounter_2 = 0;
PB.TOTcounter_3 = 0;
PB.TOTcounter_4 = 0;
PB.TOTcounter_5 = 0;
PB.TOTcounter_6 = 0;
PB.TOTcounter_7 = 0;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0;    
elseif PB.Pmax > PB.denormalised(1) && PB.Pmax <= PB.denormalised(2)
PB.TOTClmax = 2;
PB.TOTcounter_2 = PB.TOTcounter_2 + PB.TOTcounter_3 + PB.TOTcounter_4 + PB.TOTcounter_5 + PB.TOTcounter_6 + PB.TOTcounter_7 + PB.TOTcounter_8 + PB.TOTcounter_9;
PB.TOTcounter_3 = 0;
PB.TOTcounter_4 = 0;
PB.TOTcounter_5 = 0;
PB.TOTcounter_6 = 0;
PB.TOTcounter_7 = 0;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0;
elseif PB.Pmax > PB.denormalised(2) && PB.Pmax <= PB.denormalised(3)
PB.TOTClmax = 3;
PB.TOTcounter_3 = PB.TOTcounter_3 + PB.TOTcounter_4 + PB.TOTcounter_5 + PB.TOTcounter_6 + PB.TOTcounter_7 + PB.TOTcounter_8 + PB.TOTcounter_9;
PB.TOTcounter_4 = 0;
PB.TOTcounter_5 = 0;
PB.TOTcounter_6 = 0;
PB.TOTcounter_7 = 0;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0; 
elseif PB.Pmax > PB.denormalised(3) && PB.Pmax <= PB.denormalised(4)
PB.TOTClmax = 4;
PB.TOTcounter_4 = PB.TOTcounter_4 + PB.TOTcounter_5 + PB.TOTcounter_6 + PB.TOTcounter_7 + PB.TOTcounter_8 + PB.TOTcounter_9;
PB.TOTcounter_5 = 0;
PB.TOTcounter_6 = 0;
PB.TOTcounter_7 = 0;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0;   
elseif PB.Pmax > PB.denormalised(4) && PB.Pmax <= PB.denormalised(5)   
PB.TOTClmax = 5;
PB.TOTcounter_5 = PB.TOTcounter_5 + PB.TOTcounter_6 + PB.TOTcounter_7 + PB.TOTcounter_8 + PB.TOTcounter_9;
PB.TOTcounter_6 = 0;
PB.TOTcounter_7 = 0;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0;
elseif PB.Pmax > PB.denormalised(5) && PB.Pmax <= PB.denormalised(6)    
PB.TOTClmax = 6;
PB.TOTcounter_6 = PB.TOTcounter_6 + PB.TOTcounter_7 + PB.TOTcounter_8 + PB.TOTcounter_9;
PB.TOTcounter_7 = 0;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0;    
elseif PB.Pmax > PB.denormalised(6) && PB.Pmax <= PB.denormalised(7)   
PB.TOTClmax = 7;
PB.TOTcounter_7 = PB.TOTcounter_7 + PB.TOTcounter_8 + PB.TOTcounter_9;
PB.TOTcounter_8 = 0;
PB.TOTcounter_9 = 0;
elseif PB.Pmax > PB.denormalised(7) && PB.Pmax <= PB.denormalised(8)
PB.TOTClmax = 8;
PB.TOTcounter_8 = PB.TOTcounter_8 + PB.TOTcounter_9;
PB.TOTcounter_9 = 0;    
else
PB.TOTClmax = 9;   
end

%Calculation of Pwheel based on CO2 RDE trip emissions, k & D: URBAN
for i=1:length(INCAdata.IN_Vehicle_speed)-2 % Last 2 pts - Do they have their own windows?
    PB.averagevehiclespeed(i) = (INCAdata.IN_Vehicle_speed(i)+ INCAdata.IN_Vehicle_speed(i+1)+ INCAdata.IN_Vehicle_speed(i+2)) / 3; % [kW]
end
PB.averagevehiclespeed=[PB.averagevehiclespeed INCAdata.IN_Vehicle_speed(end-1) INCAdata.IN_Vehicle_speed(end)];

PB.CO2URB=zeros(length(INCAdata.IN_Vehicle_speed),1); %vector of zeros
PB.PwURB=zeros(length(INCAdata.IN_Vehicle_speed),1);
for i=2:length(PB.averagevehiclespeed)
if PB.averagevehiclespeed(i)<=60  
PB.CO2URB(i)=Input.factor_CO2_fuelconsumption_diesel*INCAdata.FQD_Chkd_inj_fuel_dmnd(i-1)*INCAdata.IN_Engine_cycle_speed(i)*0.12; %g/h %Damien book
if PB.CO2URB(i)<0
PB.CO2URB(i)=0;
else
PB.CO2URB(i)=PB.CO2URB(i);
end
if PB.averagevehiclespeed(i)<=1 && PB.CO2URB(i)<=PB.D
    PB.PwURB(i)=0;
elseif PB.averagevehiclespeed(i)>1 && PB.CO2URB(i)<0.5*PB.D
    PB.PwURB(i)=PB.Pdrag;
else
    PB.PwURB(i)=(PB.CO2URB(i)-PB.D)/PB.k; %%Kw
end
else
PB.CO2URB(i)=-5*10^6;  
PB.PwURB(i)=-5*10^6;
end
end
PB.CO2URB=PB.CO2URB(PB.CO2URB>-4.9*10^6);
PB.PwURB=PB.PwURB(PB.PwURB>-4.9*10^6);
PB.counter_urban=length (PB.CO2URB);

%Pw moving average URB
for i=1:PB.counter_urban-2 % Last 2 pts - Do they have their own windows?
    PB.Pw_averageURB(i) = (PB.PwURB(i)+ PB.PwURB(i+1)+ PB.PwURB(i+2)) / 3; % [kW]
end

%Pw_average_bins URB
PB.URBcounter_1 = 0;
PB.URBcounter_2 = 0;
PB.URBcounter_3 = 0;
PB.URBcounter_4 = 0;
PB.URBcounter_5 = 0;
PB.URBcounter_6 = 0;
PB.URBcounter_7 = 0;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0;
for i = 1:length(PB.Pw_averageURB)
if PB.Pw_averageURB(i) <= PB.denormalised(1)
PB.URBcounter_1 = PB.URBcounter_1+1;
elseif PB.Pw_averageURB(i) > PB.denormalised(1) && PB.Pw_averageURB(i) <= PB.denormalised(2)
PB.URBcounter_2 = PB.URBcounter_2+1;
elseif PB.Pw_averageURB(i) > PB.denormalised(2)  && PB.Pw_averageURB(i) <= PB.denormalised(3)
PB.URBcounter_3 = PB.URBcounter_3+1;
elseif PB.Pw_averageURB(i) >PB.denormalised(3)  && PB.Pw_averageURB(i) <= PB.denormalised(4)
PB.URBcounter_4 = PB.URBcounter_4+1;
elseif PB.Pw_averageURB(i) > PB.denormalised(4) && PB.Pw_averageURB(i) <= PB.denormalised(5)
PB.URBcounter_5 = PB.URBcounter_5+1;
elseif PB.Pw_averageURB(i) >PB.denormalised(5) && PB.Pw_averageURB(i) <= PB.denormalised(6)
PB.URBcounter_6 = PB.URBcounter_6+1;
elseif PB.Pw_averageURB(i) >PB.denormalised(6)  && PB.Pw_averageURB(i) <= PB.denormalised(7)
PB.URBcounter_7 = PB.URBcounter_7+1;
elseif PB.Pw_averageURB(i) > PB.denormalised(7) && PB.Pw_averageURB(i) <= PB.denormalised(8)
PB.URBcounter_8 = PB.URBcounter_8+1;
else 
PB.URBcounter_9 = PB.URBcounter_9+1;
end   
end

%PwMAX detection (all excluded Pw added to the highest remaining class) URB
if PB.Pmax <= PB.denormalised(1)
PB.URBClmax = 1; %class which contains Pmax
PB.URBcounter_1 = PB.URBcounter_1 + PB.URBcounter_2 + PB.URBcounter_3 + PB.URBcounter_4 + PB.URBcounter_5 + PB.URBcounter_6 + PB.URBcounter_7 + PB.URBcounter_8 + PB.URBcounter_9; %put the remaining in the higher class
PB.URBcounter_2 = 0;
PB.URBcounter_3 = 0;
PB.URBcounter_4 = 0;
PB.URBcounter_5 = 0;
PB.URBcounter_6 = 0;
PB.URBcounter_7 = 0;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0;    
elseif PB.Pmax > PB.denormalised(1) && PB.Pmax <= PB.denormalised(2)
PB.URBClmax = 2;
PB.URBcounter_2 = PB.URBcounter_2 + PB.URBcounter_3 + PB.URBcounter_4 + PB.URBcounter_5 + PB.URBcounter_6 + PB.URBcounter_7 + PB.URBcounter_8 + PB.URBcounter_9;
PB.URBcounter_3 = 0;
PB.URBcounter_4 = 0;
PB.URBcounter_5 = 0;
PB.URBcounter_6 = 0;
PB.URBcounter_7 = 0;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0;
elseif PB.Pmax > PB.denormalised(2) && PB.Pmax <= PB.denormalised(3)
PB.URBClmax = 3;
PB.URBcounter_3 = PB.URBcounter_3 + PB.URBcounter_4 + PB.URBcounter_5 + PB.URBcounter_6 + PB.URBcounter_7 + PB.URBcounter_8 + PB.URBcounter_9;
PB.URBcounter_4 = 0;
PB.URBcounter_5 = 0;
PB.URBcounter_6 = 0;
PB.URBcounter_7 = 0;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0; 
elseif PB.Pmax > PB.denormalised(3) && PB.Pmax <= PB.denormalised(4)
PB.URBClmax = 4;
PB.URBcounter_4 = PB.URBcounter_4 + PB.URBcounter_5 + PB.URBcounter_6 + PB.URBcounter_7 + PB.URBcounter_8 + PB.URBcounter_9;
PB.URBcounter_5 = 0;
PB.URBcounter_6 = 0;
PB.URBcounter_7 = 0;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0;   
elseif PB.Pmax > PB.denormalised(4) && PB.Pmax <= PB.denormalised(5)   
PB.URBClmax = 5;
PB.URBcounter_5 = PB.URBcounter_5 + PB.URBcounter_6 + PB.URBcounter_7 + PB.URBcounter_8 + PB.URBcounter_9;
PB.URBcounter_6 = 0;
PB.URBcounter_7 = 0;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0;
elseif PB.Pmax > PB.denormalised(5) && PB.Pmax <= PB.denormalised(6)    
PB.URBClmax = 6;
PB.URBcounter_6 = PB.URBcounter_6 + PB.URBcounter_7 + PB.URBcounter_8 + PB.URBcounter_9;
PB.URBcounter_7 = 0;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0;    
elseif PB.Pmax > PB.denormalised(6) && PB.Pmax <= PB.denormalised(7)   
PB.URBClmax = 7;
PB.URBcounter_7 = PB.URBcounter_7 + PB.URBcounter_8 + PB.URBcounter_9;
PB.URBcounter_8 = 0;
PB.URBcounter_9 = 0;
elseif PB.Pmax > PB.denormalised(7) && PB.Pmax <= PB.denormalised(8)
PB.URBClmax = 8;
PB.URBcounter_8 = PB.URBcounter_8 + PB.URBcounter_9;
PB.URBcounter_9 = 0;    
else
PB.URBClmax = 9;   
end

% Total & Urban check & report
fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'POWER BINNING \r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'Total trip \r\n');
fprintf (REPORT,'\r\n');

if PB.TOTClmax>=1 && PB.TOTcounter_1 <= 5    
validity = [validity 0];
fprintf (REPORT,'Power class NO 1 = %6.0f  *\r\n',PB.TOTcounter_1);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 1 = %6.0f  -\r\n',PB.TOTcounter_1);
end 

if PB.TOTClmax>=2 && PB.TOTcounter_2<=5
validity = [validity 0];
fprintf (REPORT,'Power class NO 2 = %6.0f  *\r\n',PB.TOTcounter_2);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 2 = %6.0f  -\r\n',PB.TOTcounter_2);
end 

if PB.TOTClmax>=3 && PB.TOTcounter_3<=5
validity = [validity 0];
fprintf (REPORT,'Power class NO 3 = %6.0f  *\r\n',PB.TOTcounter_3);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 3 = %6.0f  -\r\n',PB.TOTcounter_3);
end

if PB.TOTClmax>= 4 && PB.TOTcounter_4<= 5
validity = [validity 0];
fprintf (REPORT,'Power class NO 4 = %6.0f  *\r\n',PB.TOTcounter_4);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 4 = %6.0f  -\r\n',PB.TOTcounter_4);
end

if PB.TOTClmax>=5 && PB.TOTcounter_5<=5
validity = [validity 0];
fprintf (REPORT,'Power class NO 5 = %6.0f  *\r\n',PB.TOTcounter_5);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 5 = %6.0f  -\r\n',PB.TOTcounter_5); 
end

if PB.TOTClmax>=6 && PB.TOTcounter_6<=5
validity = [validity 0];
fprintf (REPORT,'Power class NO 6 = %6.0f  *\r\n',PB.TOTcounter_6);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 6 = %6.0f  -\r\n',PB.TOTcounter_6);
end

fprintf (REPORT,'\r\n');
fprintf (REPORT,'Urban part \r\n');
fprintf (REPORT,'\r\n');

if PB.URBClmax>=1 && PB.URBcounter_1 <= 5   
validity = [validity 0];
fprintf (REPORT,'Power class NO 1 = %6.0f  *\r\n',PB.URBcounter_1);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 1 = %6.0f  -\r\n',PB.URBcounter_1);
end 

if PB.URBClmax>=2 && PB.URBcounter_2<=5
validity = [validity 0];
fprintf (REPORT,'Power class NO 2 = %6.0f  *\r\n',PB.URBcounter_2);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 2 = %6.0f  -\r\n',PB.URBcounter_2);
end 

if PB.URBClmax>=3 && PB.URBcounter_3<=5
validity = [validity 0];
fprintf (REPORT,'Power class NO 3 = %6.0f  *\r\n',PB.URBcounter_3);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 3 = %6.0f  -\r\n',PB.URBcounter_3);
end

if PB.URBClmax>= 4 && PB.URBcounter_4<= 5
validity = [validity 0];
fprintf (REPORT,'Power class NO 4 = %6.0f  *\r\n',PB.URBcounter_4);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 4 = %6.0f  -\r\n',PB.URBcounter_4);
end

if PB.URBClmax>=5 && PB.URBcounter_5<=5
validity = [validity 0];
fprintf (REPORT,'Power class NO 5 = %6.0f  *\r\n',PB.URBcounter_5);
else
validity=[validity 1];
fprintf (REPORT,'Power class NO 5 = %6.0f  -\r\n',PB.URBcounter_5);
end

% app.PBTotalBinsClass1EditField.Value=PB.TOTcounter_1;
% app.PBTotalBinsClass2EditField.Value=PB.TOTcounter_2;
% app.PBTotalBinsClass3EditField.Value=PB.TOTcounter_3;
% app.PBTotalBinsClass4EditField.Value=PB.TOTcounter_4;
% app.PBTotalBinsClass5EditField.Value=PB.TOTcounter_5;
% app.PBTotalBinsClass6EditField.Value=PB.TOTcounter_6;
% app.PBUrbanBinsClass1EditField.Value=PB.URBcounter_1;
% app.PBUrbanBinsClass2EditField.Value=PB.URBcounter_2;
% app.PBUrbanBinsClass3EditField.Value=PB.URBcounter_3;
% app.PBUrbanBinsClass4EditField.Value=PB.URBcounter_4;
% app.PBUrbanBinsClass5EditField.Value=PB.URBcounter_5;

%% MAW METHOD
fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'MAW \r\n');
fprintf (REPORT,'\r\n');
MAW.CO2Partial=PB.CO2TOT/3600; %g/s
MAW.CO2ref=Input.CO2_reference_g; %g (half of WLTC CO2) HONDA

%% Number of Windows definition: method 1: CORRECT

for i=1:length(MAW.CO2Partial)
if INCAdata.IN_Vehicle_speed(i)>=1
MAW.CO2TOT(i)=MAW.CO2Partial(i);
MAW.VehicleSpeed(i)=INCAdata.IN_Vehicle_speed(i);
MAW.NOxTOT(i)=Emissions.NOxmass(i);
else
MAW.CO2TOT(i)=-5000;
MAW.VehicleSpeed(i)=-5000;
MAW.NOxTOT(i)=-5000;
end
end
MAW.CO2TOT=MAW.CO2TOT(MAW.CO2TOT>-4900); %exclude all the points v<1 km/h
MAW.VehicleSpeed=MAW.VehicleSpeed(MAW.VehicleSpeed>-4900);
MAW.NOxTOT=MAW.NOxTOT(MAW.NOxTOT>-4900);

MAW.flag=0;
MAW.distancedef (1)=0;
MAW.timedef(1)=0;
MAW.CO2def(1)=0;
MAW.NOxdef(1)=0;
for i=2:length(MAW.CO2TOT)%i=number of window (i start from 2 because of for cycle) 
for k=i:length (MAW.CO2TOT)
MAW.CO2def(k)=MAW.CO2def(k-1)+MAW.CO2TOT(k);
MAW.NOxdef(k)=MAW.NOxdef(k-1)+MAW.NOxTOT(k);
MAW.distancedef (k) =MAW.distancedef (k-1) + ((MAW.VehicleSpeed(k))/3600);%km
MAW.timedef(k)=MAW.timedef(k-1)+1;
if MAW.CO2def(k)>=MAW.CO2ref
MAW.flag=0;
break
else
MAW.flag=1; %if I do not reach 50% it goes out from 1st for cycle (smaller)
end
end
if MAW.flag==0 
MAW.CO2window(i)=MAW.CO2def(k); %g (CO2 emission for each window)
MAW.NOxwindow(i)=MAW.NOxdef(k); %g (NOx emission for each window)
MAW.distancewindow (i)=MAW.distancedef (k);%km (distance of each window)
MAW.timewindow (i)=MAW.timedef (k);
MAW.CO2def(i)=0;
MAW.NOxdef(i)=0;
MAW.distancedef (i)=0;
MAW.timedef(i)=0;
else
break %if I do not reach 50% it goes out from 2nd for cycle (bigger)
end
end
MAW.CO2window=MAW.CO2window(2:end);%the first point is not a window;
MAW.NOxwindow=MAW.NOxwindow(2:end);
MAW.distancewindow=MAW.distancewindow(2:end);
MAW.timewindow=MAW.timewindow(2:end);
MAW.NumberofWindows=length (MAW.CO2window); 
MAW.CO2gkmWindows=MAW.CO2window./MAW.distancewindow; %g/km
MAW.NOxgkmWindows=MAW.NOxwindow./MAW.distancewindow; %g/km
MAW.averagespeedWindows=3600*MAW.distancewindow./MAW.timewindow;

%% Completeness check
MAW.urbanwindows=0;
MAW.ruralwindows=0;
MAW.motorwaywindows=0;
for i=1:MAW.NumberofWindows
if MAW.averagespeedWindows(i)<=45
MAW.urbanwindows=MAW.urbanwindows+1;
elseif MAW.averagespeedWindows(i)<=80 && MAW.averagespeedWindows(i)>45
MAW.ruralwindows=MAW.ruralwindows+1;
else
MAW.motorwaywindows=MAW.motorwaywindows+1;
end
end
MAW.urbanwindowsratio=100*MAW.urbanwindows/MAW.NumberofWindows;
MAW.ruralwindowsratio=100*MAW.ruralwindows/MAW.NumberofWindows;
MAW.motorwaywindowsratio=100*MAW.motorwaywindows/MAW.NumberofWindows;
fprintf (REPORT,'Completeness check \r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'Urban windows  = %6.0f   \r\n',MAW.urbanwindows);
fprintf (REPORT,'Rural windows  = %6.0f   \r\n',MAW.ruralwindows);
fprintf (REPORT,'Motorway windows  = %6.0f   \r\n',MAW.motorwaywindows);
if MAW.urbanwindowsratio>15
validity=[validity 1];
fprintf (REPORT,'Urban windows ratio = %6.2f %%   -\r\n',MAW.urbanwindowsratio);
else 
validity = [validity 0];
fprintf (REPORT,'Urban windows ratio = %6.2f %%   *\r\n',MAW.urbanwindowsratio);
end
if MAW.ruralwindowsratio>15
validity=[validity 1];
fprintf (REPORT,'Rural windows ratio = %6.2f %%   -\r\n',MAW.ruralwindowsratio);
else 
validity = [validity 0];
fprintf (REPORT,'Rural windows ratio = %6.2f %%   *\r\n',MAW.ruralwindowsratio);
end
if MAW.motorwaywindowsratio>15
validity=[validity 1];
fprintf (REPORT,'Motorway windows ratio = %6.2f %%   -\r\n',MAW.motorwaywindowsratio);
else 
validity = [validity 0];
fprintf (REPORT,'Motorway windows ratio = %6.2f %%   *\r\n',MAW.motorwaywindowsratio);
end

% app.UrbanwindowsEditField.Value=MAW.urbanwindows;
% app.RuralwindowsEditField.Value=MAW.ruralwindows;
% app.MotorwaywindowsEditField.Value=MAW.motorwaywindows;
% app.UrbwindowratioEditField.Value=MAW.urbanwindowsratio;
% app.RurwindowratioEditField.Value=MAW.ruralwindowsratio;
% app.MotwindowratioEditField.Value=MAW.motorwaywindowsratio;

%% Normality check PACK 3
MAW.CO2lowspeed=Input.CO2_lowspeed_phase_gkm; %g/km HONDA
MAW.CO2highspeed=Input.CO2_highspeed_phase_gkm; %g/km HONDA
MAW.CO2exhighspeed=Input.CO2_extrahighspeed_phase_gkm; %g/km HONDA
MAW.referencespeed= [19.0, 56.6, 92.3];
MAW.referenceCO2_pack3= [1.2*MAW.CO2lowspeed, 1.1*MAW.CO2highspeed, 1.05*MAW.CO2exhighspeed]; %pack3
MAW.tol1=[0.25 0.26 0.27 0.28 0.29 0.30];
MAW.urbannormalwindows=zeros (length(MAW.tol1),1);
MAW.ruralnormalwindows=zeros(length(MAW.tol1),1);
MAW.motorwaynormalwindows=zeros(length(MAW.tol1),1);
MAW.black_1=zeros(MAW.NumberofWindows,1);
MAW.black_2=zeros(MAW.NumberofWindows,1);

% Definition of normal urban, rural and motorway windows
for z=1:length(MAW.tol1)
for i=1:MAW.NumberofWindows 
MAW.black_1(i)=MAW.referenceCO2_pack3(1)+((MAW.averagespeedWindows(i)-MAW.referencespeed(1))*(MAW.referenceCO2_pack3(2)-MAW.referenceCO2_pack3(1))/(MAW.referencespeed(2)-MAW.referencespeed(1)));%respective y of our x in 1st line
MAW.black_2(i)=MAW.referenceCO2_pack3(2)+((MAW.averagespeedWindows(i)-MAW.referencespeed(2))*(MAW.referenceCO2_pack3(3)-MAW.referenceCO2_pack3(2))/(MAW.referencespeed(3)-MAW.referencespeed(2)));%respective y of our x in 2nd line
if MAW.averagespeedWindows(i)<=45
if MAW.CO2gkmWindows(i)<((1+MAW.tol1(z))*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_1(i)) %%tol 1 - is fixed
MAW.urbannormalwindows(z)=MAW.urbannormalwindows(z)+1;
else
MAW.urbannormalwindows(z)=MAW.urbannormalwindows(z);
end
end
if MAW.averagespeedWindows(i)>45 && MAW.averagespeedWindows(i)<=56.6
if MAW.CO2gkmWindows(i)<((1+MAW.tol1(z))*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_1(i))
MAW.ruralnormalwindows(z)=MAW.ruralnormalwindows(z)+1;
else
MAW.ruralnormalwindows(z)=MAW.ruralnormalwindows(z);
end
end
if MAW.averagespeedWindows(i)>56.6 && MAW.averagespeedWindows(i)<=80
if MAW.CO2gkmWindows(i)<((1+MAW.tol1(z))*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)>((1-0.25)*MAW.black_2(i))
MAW.ruralnormalwindows(z)=MAW.ruralnormalwindows(z)+1;
else
MAW.ruralnormalwindows(z)=MAW.ruralnormalwindows(z);
end
end
if MAW.averagespeedWindows(i)>80 
if MAW.CO2gkmWindows(i)<((1+MAW.tol1(z))*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_2(i))
MAW.motorwaynormalwindows(z)=MAW.motorwaynormalwindows(z)+1;
else
MAW.motorwaynormalwindows(z)=MAW.motorwaynormalwindows(z);
end
end
end
end

%Normality check & report
MAW.flagnormalityurban=0;
MAW.flagnormalityrural=0;    
MAW.flagnormalitymotorway=0;
for z=1:length(MAW.tol1)
if (MAW.urbannormalwindows(z)>=0.5*MAW.urbanwindows) 
MAW.flagnormalityurban=1;
else
MAW.flagnormalityurban=0;    
end
if (MAW.ruralnormalwindows(z)>0.5*MAW.ruralwindows) 
MAW.flagnormalityrural=1;
else
MAW.flagnormalityrural=0;    
end
if (MAW.motorwaynormalwindows(z)>0.5*MAW.motorwaywindows)
MAW.flagnormalitymotorway=1;
else
MAW.flagnormalitymotorway=0;    
end
if (MAW.flagnormalityurban==1)&& (MAW.flagnormalityrural==1)&&(MAW.flagnormalitymotorway==1)
break
end
end
MAW.tol1_def=100*MAW.tol1(z);
MAW.urbannormalwindows_def=MAW.urbannormalwindows(z);
MAW.ruralnormalwindows_def=MAW.ruralnormalwindows(z);
MAW.motorwaynormalwindows_def=MAW.motorwaynormalwindows(z);
MAW.urbannormalityratio=100*MAW.urbannormalwindows_def/MAW.urbanwindows;
MAW.ruralnormalityratio=100*MAW.ruralnormalwindows_def/MAW.ruralwindows;
MAW.motorwaynormalityratio=100*MAW.motorwaynormalwindows_def/MAW.motorwaywindows;

fprintf (REPORT,'\r\n');
fprintf (REPORT,'Normality check PACK 3 \r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'Tol 1 + = %6.0f%%   \r\n',MAW.tol1_def); 
fprintf (REPORT,'Tol 1 - = 25%% fixed   \r\n');
fprintf (REPORT,'Urban normal windows = %6.0f   \r\n',MAW.urbannormalwindows_def);
fprintf (REPORT,'Rural normal windows = %6.0f   \r\n',MAW.ruralnormalwindows_def);
fprintf (REPORT,'Motorway normal windows = %6.0f  \r\n',MAW.motorwaynormalwindows_def);

if(MAW.flagnormalityurban==1)
validity=[validity 1];
fprintf (REPORT,'Urban normal windows ratio = %6.2f %%   -\r\n',MAW.urbannormalityratio);
else 
validity = [validity 0];
fprintf (REPORT,'Urban normal windows ratio= %6.2f %%   *\r\n',MAW.urbannormalityratio);
end   
if(MAW.flagnormalityrural==1)
validity=[validity 1];
fprintf (REPORT,'Rural normal windows ratio= %6.2f %%  -\r\n',MAW.ruralnormalityratio);
else 
validity = [validity 0];
fprintf (REPORT,'Rural normal windows ratio= %6.2f %%   *\r\n',MAW.ruralnormalityratio);
end 
if(MAW.flagnormalitymotorway==1)
validity=[validity 1];
fprintf (REPORT,'Motorway normal windows ratio= %6.2f %%  -\r\n',MAW.motorwaynormalityratio);
else 
validity = [validity 0];
fprintf (REPORT,'Motorway normal windows ratio= %6.2f %%   *\r\n',MAW.motorwaynormalityratio);
end

% app.Urbannormalwindows3EditField.Value=MAW.urbannormalwindows_def;
% app.Ruralnormalwindows3EditField.Value=MAW.ruralnormalwindows_def;
% app.Motorwaynormalwindows3EditField.Value=MAW.motorwaynormalwindows_def;
% app.Urbnormalwindowratio3EditField.Value=MAW.urbannormalityratio;
% app.Rurnormalwindowratio3EditField.Value=MAW.ruralnormalityratio;
% app.Motnormalwindowratio3EditField.Value=MAW.motorwaynormalityratio;
% app.TOL1Pack3EditField.Value=MAW.tol1_def;

%% MAW normality PACK 4
MAW.referencespeed= [18.882, 56.664, 91.997];
MAW.referenceCO2_pack4= [MAW.CO2lowspeed, MAW.CO2highspeed, MAW.CO2exhighspeed]; %pack4
MAW.black_1_4=zeros(MAW.NumberofWindows,1);
MAW.black_2_4=zeros(MAW.NumberofWindows,1);
MAW.urbannormalwindows4=0;
MAW.ruralnormalwindows4=0;
MAW.motorwaynormalwindows4=0;

% if MAW.choice==1
MAW.tol1_urb=45; %ICE
MAW.tol1_rurmot=40; %ICE
% else
% MAW.tol1_urb=50; %HEV
% MAW.tol1_rurmot=50; %HEV
% end

% Definition of normal urban, rural and motorway windows
for i=1:MAW.NumberofWindows 
MAW.black_1_4(i)=MAW.referenceCO2_pack4(1)+((MAW.averagespeedWindows(i)-MAW.referencespeed(1))*(MAW.referenceCO2_pack4(2)-MAW.referenceCO2_pack4(1))/(MAW.referencespeed(2)-MAW.referencespeed(1)));
MAW.black_2_4(i)=MAW.referenceCO2_pack4(2)+((MAW.averagespeedWindows(i)-MAW.referencespeed(2))*(MAW.referenceCO2_pack4(3)-MAW.referenceCO2_pack4(2))/(MAW.referencespeed(3)-MAW.referencespeed(2)));
if MAW.averagespeedWindows(i)<=45
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_urb/100)*MAW.black_1_4(i)) &&  MAW.CO2gkmWindows(i)> (0.75*MAW.black_1_4(i)) %green up variable, green down fixed
MAW.urbannormalwindows4=MAW.urbannormalwindows4+1;
else
MAW.urbannormalwindows4=MAW.urbannormalwindows4;
end
end
if MAW.averagespeedWindows(i)>45 && MAW.averagespeedWindows(i)<=56.6
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_rurmot/100)*MAW.black_1_4(i)) &&  MAW.CO2gkmWindows(i)> (0.75*MAW.black_1_4(i))%green up & green down fixed
MAW.ruralnormalwindows4=MAW.ruralnormalwindows4+1;
else
MAW.ruralnormalwindows4=MAW.ruralnormalwindows4;
end
end
if MAW.averagespeedWindows(i)>56.6 && MAW.averagespeedWindows(i)<=80
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_rurmot/100)*MAW.black_2_4(i)) &&  MAW.CO2gkmWindows(i)>(0.75*MAW.black_2_4(i))%green up & green down fixed
MAW.ruralnormalwindows4=MAW.ruralnormalwindows4+1;
else
MAW.ruralnormalwindows4=MAW.ruralnormalwindows4;
end
end
if MAW.averagespeedWindows(i)>80 
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_rurmot/100)*MAW.black_2_4(i)) &&  MAW.CO2gkmWindows(i)> (0.75*MAW.black_2_4(i))%green up & green down fixed
MAW.motorwaynormalwindows4=MAW.motorwaynormalwindows4+1;
else
MAW.motorwaynormalwindows4=MAW.motorwaynormalwindows4;
end
end
end


%Normality check & report
MAW.flagnormalityurban4=0;
MAW.flagnormalityrural4=0;    
MAW.flagnormalitymotorway4=0;
if (MAW.urbannormalwindows4>=0.5*MAW.urbanwindows) 
MAW.flagnormalityurban4=1;
else
MAW.flagnormalityurban4=0;    
end
if (MAW.ruralnormalwindows4>0.5*MAW.ruralwindows) 
MAW.flagnormalityrural4=1;
else
MAW.flagnormalityrural4=0;    
end
if (MAW.motorwaynormalwindows4>0.5*MAW.motorwaywindows)
MAW.flagnormalitymotorway4=1;
else
MAW.flagnormalitymotorway4=0;    
end

MAW.urbannormalwindows_def4=MAW.urbannormalwindows4;
MAW.ruralnormalwindows_def4=MAW.ruralnormalwindows4;
MAW.motorwaynormalwindows_def4=MAW.motorwaynormalwindows4;
MAW.urbannormalityratio4=100*MAW.urbannormalwindows_def4/MAW.urbanwindows;
MAW.ruralnormalityratio4=100*MAW.ruralnormalwindows_def4/MAW.ruralwindows;
MAW.motorwaynormalityratio4=100*MAW.motorwaynormalwindows_def4/MAW.motorwaywindows;

fprintf (REPORT,'\r\n');
fprintf (REPORT,'Normality check PACK 4 \r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'Tol 1 Urban + = 45%% fixed \r\n'); 
fprintf (REPORT,'Tol 1 Rural & Motorway = 40%% fixed \r\n'); 
fprintf (REPORT,'Tol 1 Urban & Rural & Motorway - = 25%% fixed \r\n'); 
fprintf (REPORT,'Urban normal windows = %6.0f   \r\n',MAW.urbannormalwindows_def4);
fprintf (REPORT,'Rural normal windows = %6.0f   \r\n',MAW.ruralnormalwindows_def4);
fprintf (REPORT,'Motorway normal windows = %6.0f  \r\n',MAW.motorwaynormalwindows_def4);

if(MAW.flagnormalityurban4==1)
validity=[validity 1];
fprintf (REPORT,'Urban normal windows ratio = %6.2f %%   -\r\n',MAW.urbannormalityratio4);
else 
validity = [validity 0];
fprintf (REPORT,'Urban normal windows ratio= %6.2f %%   *\r\n',MAW.urbannormalityratio4);
end   
if(MAW.flagnormalityrural4==1)
validity=[validity 1];
fprintf (REPORT,'Rural normal windows ratio= %6.2f %%  -\r\n',MAW.ruralnormalityratio4);
else 
validity = [validity 0];
fprintf (REPORT,'Rural normal windows ratio= %6.2f %%   *\r\n',MAW.ruralnormalityratio4);
end 
if(MAW.flagnormalitymotorway4==1)
validity=[validity 1];
fprintf (REPORT,'Motorway normal windows ratio= %6.2f %%  -\r\n',MAW.motorwaynormalityratio4);
else 
validity = [validity 0];
fprintf (REPORT,'Motorway normal windows ratio= %6.2f %%   *\r\n',MAW.motorwaynormalityratio4);
end

% app.Urbannormalwindows4EditField.Value=MAW.urbannormalwindows_def4;
% app.Ruralnormalwindows4EditField.Value=MAW.ruralnormalwindows_def4;
% app.Motorwaynormalwindows4EditField.Value=MAW.motorwaynormalwindows_def4;
% app.Urbnormalwindowratio4EditField.Value=MAW.urbannormalityratio4;
% app.Rurnormalwindowratio4EditField.Value=MAW.ruralnormalityratio4;
% app.Motnormalwindowratio4EditField.Value=MAW.motorwaynormalityratio4;
% app.TOL1URBANPack4EditField.Value=MAW.tol1_urb;

%% Draw MAW reference curve 

%Definition of x & y
MAW.x_1=0:0.1:56.6;
MAW.x_2=56.6:0.1:150;
MAW.y_pack3_1_black=MAW.referenceCO2_pack3(1)+(MAW.x_1-MAW.referencespeed(1))*(MAW.referenceCO2_pack3(2)-MAW.referenceCO2_pack3(1))/(MAW.referencespeed(2)-MAW.referencespeed(1));
MAW.y_pack3_2_black=MAW.referenceCO2_pack3(2)+(MAW.x_2-MAW.referencespeed(2))*(MAW.referenceCO2_pack3(3)-MAW.referenceCO2_pack3(2))/(MAW.referencespeed(3)-MAW.referencespeed(2));
MAW.y_pack3_1_green_up=(1+MAW.tol1_def/100)*MAW.y_pack3_1_black; %it draws green line related to tol1 calculated (from 0.25 to 0.30)
MAW.y_pack3_1_green_down=(1-0.25)*MAW.y_pack3_1_black;%tol 1 - is fixed
MAW.y_pack3_1_red_up=1.50*MAW.y_pack3_1_black;%fixed
MAW.y_pack3_1_red_down=0.50*MAW.y_pack3_1_black;%fixed
MAW.y_pack3_2_green_up=(1+MAW.tol1_def/100)*MAW.y_pack3_2_black; %it draws green line related to tol1 calculated (from 0.25 to 0.30)
MAW.y_pack3_2_green_down=(1-0.25)*MAW.y_pack3_2_black;%it draws green line related to tol1 calculated (from 0.25 to 0.30)
MAW.y_pack3_2_red_up=1.50*MAW.y_pack3_2_black;%fixed
MAW.y_pack3_2_red_down=0.50*MAW.y_pack3_2_black;%fixed

MAW.y_pack4_1_black=MAW.referenceCO2_pack4(1)+(MAW.x_1-MAW.referencespeed(1))*(MAW.referenceCO2_pack4(2)-MAW.referenceCO2_pack4(1))/(MAW.referencespeed(2)-MAW.referencespeed(1));
MAW.y_pack4_2_black=MAW.referenceCO2_pack4(2)+(MAW.x_2-MAW.referencespeed(2))*(MAW.referenceCO2_pack4(3)-MAW.referenceCO2_pack4(2))/(MAW.referencespeed(3)-MAW.referencespeed(2));
MAW.y_pack4_1_green_up1=(1+MAW.tol1_urb/100)*MAW.y_pack4_1_black;
MAW.y_pack4_1_green_up2=(1+MAW.tol1_rurmot/100)*MAW.y_pack4_1_black; %tol fixed (rural & motorway)
MAW.y_pack4_1_green_down=0.75*MAW.y_pack4_1_black;%fixed
MAW.y_pack4_2_green_up=(1+MAW.tol1_rurmot/100)*MAW.y_pack4_2_black; 
MAW.y_pack4_2_green_down=0.75*MAW.y_pack4_2_black;%fixed

MAW.yurbanrural=0:50:250;
MAW.xurbanrural=45*ones(length(MAW.yurbanrural)); 
MAW.yruralmotorway=0:50:250;
MAW.xruralmotorway=80*ones(length(MAW.yruralmotorway)); 

%Definition of green & red points PACK 3
for i=1:MAW.NumberofWindows 
MAW.black_1(i)=MAW.referenceCO2_pack3(1)+((MAW.averagespeedWindows(i)-MAW.referencespeed(1))*(MAW.referenceCO2_pack3(2)-MAW.referenceCO2_pack3(1))/(MAW.referencespeed(2)-MAW.referencespeed(1)));%sarebbe la y rispettiva per la nostra x del punto (average speed) nella prima retta
MAW.black_2(i)=MAW.referenceCO2_pack3(2)+((MAW.averagespeedWindows(i)-MAW.referencespeed(2))*(MAW.referenceCO2_pack3(3)-MAW.referenceCO2_pack3(2))/(MAW.referencespeed(3)-MAW.referencespeed(2)));%sarebbe la y rispettiva per la nostra x del punto (average speed) nella seconda retta
if MAW.averagespeedWindows(i)<=45
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_1(i)) %0.25 fixed
MAW.color3(i)=1;
else
MAW.color3(i)=2;
end
end
if MAW.averagespeedWindows(i)>45 && MAW.averagespeedWindows(i)<=56.6
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_1(i))
MAW.color3(i)=1;
else
MAW.color3(i)=2;
end
end
if MAW.averagespeedWindows(i)>56.6 && MAW.averagespeedWindows(i)<=80
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)>((1-0.25)*MAW.black_2(i))
MAW.color3(i)=1;
else
MAW.color3(i)=2;
end
end
if MAW.averagespeedWindows(i)>80 
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_2(i))
MAW.color3(i)=1;
else
MAW.color3(i)=2;
end
end
end

for i=1:length(MAW.CO2gkmWindows)
MAW.matpack3(i,:)=[MAW.averagespeedWindows(i),MAW.CO2gkmWindows(i),MAW.color3(i)];
end

MAW.greenpointsPACK3=find(MAW.matpack3(:,3)==1);
MAW.redpointsPACK3=find(MAW.matpack3(:,3)==2);

%Definition of green & red points PACK 4
for i=1:MAW.NumberofWindows 
MAW.black_1_4(i)=MAW.referenceCO2_pack4(1)+((MAW.averagespeedWindows(i)-MAW.referencespeed(1))*(MAW.referenceCO2_pack4(2)-MAW.referenceCO2_pack4(1))/(MAW.referencespeed(2)-MAW.referencespeed(1)));%sarebbe la y rispettiva per la nostra x del punto (average speed) nella prima retta
MAW.black_2_4(i)=MAW.referenceCO2_pack4(2)+((MAW.averagespeedWindows(i)-MAW.referencespeed(2))*(MAW.referenceCO2_pack4(3)-MAW.referenceCO2_pack4(2))/(MAW.referencespeed(3)-MAW.referencespeed(2)));%sarebbe la y rispettiva per la nostra x del punto (average speed) nella seconda retta
if MAW.averagespeedWindows(i)<=45
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_urb/100)*MAW.black_1_4(i)) &&  MAW.CO2gkmWindows(i)> (0.75*MAW.black_1_4(i))  %only in urban part tol 1 can increase
MAW.color4(i)=1;
else
MAW.color4(i)=2;
end
end
if MAW.averagespeedWindows(i)>45 && MAW.averagespeedWindows(i)<=56.6
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_rurmot/100)*MAW.black_1_4(i)) &&  MAW.CO2gkmWindows(i)> (0.75*MAW.black_1_4(i))
MAW.color4(i)=1;
else
MAW.color4(i)=2;
end
end
if MAW.averagespeedWindows(i)>56.6 && MAW.averagespeedWindows(i)<=80
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_rurmot/100)*MAW.black_2_4(i)) &&  MAW.CO2gkmWindows(i)>(0.75*MAW.black_2_4(i))
MAW.color4(i)=1;
else
MAW.color4(i)=2;
end
end
if MAW.averagespeedWindows(i)>80 
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_rurmot/100)*MAW.black_2_4(i)) &&  MAW.CO2gkmWindows(i)> (0.75*MAW.black_2_4(i))
MAW.color4(i)=1;
else
MAW.color4(i)=2;
end
end
end

for i=1:length(MAW.CO2gkmWindows)
MAW.matpack4(i,:)=[MAW.averagespeedWindows(i),MAW.CO2gkmWindows(i),MAW.color4(i)];
end

MAW.greenpointsPACK4=find(MAW.matpack4(:,3)==1);
MAW.redpointsPACK4=find(MAW.matpack4(:,3)==2);

%Pack 3 draw
fig_name = 'MAW curve pack3';
figure(5)
plot (MAW.x_1,MAW.y_pack3_1_black,'k');
hold on
plot (MAW.x_1,MAW.y_pack3_1_green_up,'g');
hold on
plot (MAW.x_1,MAW.y_pack3_1_red_up,'r');
legend('CO2 reference curve','Tol 1','Tol 2')
hold on
plot (MAW.x_1,MAW.y_pack3_1_green_down,'g');
hold on
plot (MAW.x_1,MAW.y_pack3_1_red_down,'r');
hold on
plot (MAW.x_2,MAW.y_pack3_2_black,'k');
hold on
plot (MAW.x_2,MAW.y_pack3_2_green_up,'g');
hold on
plot (MAW.x_2,MAW.y_pack3_2_green_down,'g');
hold on
plot (MAW.x_2,MAW.y_pack3_2_red_up,'r');
hold on
plot (MAW.x_2,MAW.y_pack3_2_red_down,'r');
hold on
scatter (MAW.matpack3(MAW.greenpointsPACK3,1),MAW.matpack3(MAW.greenpointsPACK3,2),'og');
hold on
scatter (MAW.matpack3(MAW.redpointsPACK3,1),MAW.matpack3(MAW.redpointsPACK3,2),'or');
hold on
plot (MAW.xurbanrural,MAW.yurbanrural,'k--')
hold on
plot (MAW.xruralmotorway,MAW.yruralmotorway,'k--')
xlim([0 150]);
ylim([0 400]);
xlabel('Vehicle Speed [km/h]','FontSize',10,'FontAngle','italic','FontWeight','bold')
ylabel('CO2 values [g/km]','FontSize',10,'FontAngle','italic','FontWeight','bold')
text (110,28,['Tol 1 + = ',num2str(MAW.tol1_def),' %'],'Color','green','FontSize',10);
text (110,17,'Tol 1 - = 25 % fixed','Color','green','FontSize',10);
text (110,6,'Tol 2 = 50 % fixed','Color','red','FontSize',10);
title('MAW curve pack3','FontSize',12,'FontAngle','italic','FontWeight','bold')
saveas(gcf,strcat(Savepath,fig_name),'fig');

%Pack 4 draw
fig_name = 'MAW curve pack4';
figure(6)
plot (MAW.x_1,MAW.y_pack4_1_black,'k');
hold on
plot (MAW.x_1(1:451),MAW.y_pack4_1_green_up1(1:451),'g'); 
legend('CO2 reference curve','Tol 1')
hold on
plot (MAW.x_1(452:end),MAW.y_pack4_1_green_up2(452:end),'g');
hold on
plot (MAW.x_2,MAW.y_pack4_2_black,'k');
hold on
plot (MAW.x_1,MAW.y_pack4_1_green_down,'g');
hold on
plot (MAW.x_2,MAW.y_pack4_2_green_up,'g');
hold on
plot (MAW.x_2,MAW.y_pack4_2_green_down,'g');
hold on
scatter (MAW.matpack4(MAW.greenpointsPACK4,1),MAW.matpack4(MAW.greenpointsPACK4,2),'og');
hold on
scatter (MAW.matpack4(MAW.redpointsPACK4,1),MAW.matpack4(MAW.redpointsPACK4,2),'or');
hold on
plot (MAW.xurbanrural,MAW.yurbanrural,'k--')
hold on
plot (MAW.xruralmotorway,MAW.yruralmotorway,'k--')
xlim([0 150]);
ylim([0 400]);
xlabel('Vehicle Speed [km/h]','FontSize',10,'FontAngle','italic','FontWeight','bold')
ylabel('CO2 values [g/km]','FontSize',10,'FontAngle','italic','FontWeight','bold')
text (40,28,['Tol 1 + for urban part = ',num2str(MAW.tol1_urb),' %'],'Color','green','FontSize',10);
text (40,8,['Tol 1 + for rural and motorway part = ',num2str(MAW.tol1_rurmot),' %'],'Color','green','FontSize',10);
text (40,18,'Tol 1 - for urban,rural and motorway part = 25% fixed','Color','green','FontSize',10);
title('MAW curve pack4','FontSize',12,'FontAngle','italic','FontWeight','bold')
saveas(gcf,strcat(Savepath,fig_name),'fig');
close all %to close all the images (they are saved)

%% TEST VALIDITY

flagvalidity=0; %0=valid
for i=1: length (validity)
if validity(i)==0
flagvalidity=1;
break
end
end

if flagvalidity==0
fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'TEST VALID!!\r\n');
else
fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'TEST NOT VALID!!\r\n');
end


%% NOx EMISSIONS

fprintf (REPORT,'\r\n');
fprintf (REPORT,'\r\n');
fprintf (REPORT,'EMISSIONS\r\n');

%MAW NOx emissions: PACK 3
Emissions.coldstartwindows=0;
for i=1:Coldstart.endofcoldstart
if INCAdata.IN_Vehicle_speed(i)>1
Emissions.coldstartwindows=Emissions.coldstartwindows+1; %Number of windows in cold start (they shall be less than Coldstart.endofcoldstart)
else
Emissions.coldstartwindows=Emissions.coldstartwindows;
end
end
    
for i=1:MAW.NumberofWindows 
MAW.black_1(i)=MAW.referenceCO2_pack3(1)+((MAW.averagespeedWindows(i)-MAW.referencespeed(1))*(MAW.referenceCO2_pack3(2)-MAW.referenceCO2_pack3(1))/(MAW.referencespeed(2)-MAW.referencespeed(1)));%sarebbe la y rispettiva per la nostra x del punto (average speed) nella prima retta
MAW.black_2(i)=MAW.referenceCO2_pack3(2)+((MAW.averagespeedWindows(i)-MAW.referencespeed(2))*(MAW.referenceCO2_pack3(3)-MAW.referenceCO2_pack3(2))/(MAW.referencespeed(3)-MAW.referencespeed(2)));%sarebbe la y rispettiva per la nostra x del punto (average speed) nella seconda retta
Emissions.MAW_index1(i)=100*(MAW.CO2gkmWindows(i)-MAW.black_1(i))/MAW.black_1(i);
Emissions.MAW_index2(i)=100*(MAW.CO2gkmWindows(i)-MAW.black_2(i))/MAW.black_2(i);

if MAW.averagespeedWindows(i)<=45 && i<=Emissions.coldstartwindows
Emissions.MAW_urbandenominator(i)=1;
Emissions.MAW_urbannumerator(i)=Emissions.MAW_urbandenominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)<=45 && i>Emissions.coldstartwindows
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_1(i)) %tol1minus=0.25
Emissions.MAW_urbandenominator(i)=1;
elseif MAW.CO2gkmWindows(i)>((1+MAW.tol1_def/100)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)<((1+0.5)*MAW.black_1(i)) %tol2plus=0.5
Emissions.MAW_urbandenominator(i)=(Emissions.MAW_index1(i)/(MAW.tol1_def-50))+ (50/(50-MAW.tol1_def));
elseif MAW.CO2gkmWindows(i)>((1-0.5)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)<((1-0.25)*MAW.black_1(i)) %tol2minus=0.5
Emissions.MAW_urbandenominator(i)=(Emissions.MAW_index1(i)/(50-MAW.tol1_def))+ (50/(50-MAW.tol1_def));
else
Emissions.MAW_urbandenominator(i)=0;
end
Emissions.MAW_urbannumerator(i)=Emissions.MAW_urbandenominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)> 45
Emissions.MAW_urbannumerator(i)=-100;
Emissions.MAW_urbandenominator(i)=-100;
end

if MAW.averagespeedWindows(i)>45 && MAW.averagespeedWindows(i)<=56.6 && i<=Emissions.coldstartwindows
Emissions.MAW_rural1denominator(i)=1;
Emissions.MAW_rural1numerator(i)=Emissions.MAW_rural1denominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)>45 && MAW.averagespeedWindows(i)<=56.6 && i>Emissions.coldstartwindows
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_1(i)) %tol1minus=0.25
Emissions.MAW_rural1denominator(i)=1;
elseif MAW.CO2gkmWindows(i)>((1+MAW.tol1_def/100)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)<((1+0.5)*MAW.black_1(i)) %tol2plus=0.5
Emissions.MAW_rural1denominator(i)=(Emissions.MAW_index1(i)/(MAW.tol1_def-50))+ (50/(50-MAW.tol1_def));
elseif MAW.CO2gkmWindows(i)>((1-0.5)*MAW.black_1(i)) &&  MAW.CO2gkmWindows(i)<((1-0.25)*MAW.black_1(i)) %tol2minus=0.5
Emissions.MAW_rural1denominator(i)=(Emissions.MAW_index1(i)/(50-MAW.tol1_def))+ (50/(50-MAW.tol1_def));
else
Emissions.MAW_rural1denominator(i)=0;
end
Emissions.MAW_rural1numerator(i)=Emissions.MAW_rural1denominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)< 45 || MAW.averagespeedWindows(i)> 56.6
Emissions.MAW_rural1numerator(i)=-100;
Emissions.MAW_rural1denominator(i)=-100;
end

if MAW.averagespeedWindows(i)>56.6 && MAW.averagespeedWindows(i)<=80 && i<=Emissions.coldstartwindows
Emissions.MAW_rural2denominator(i)=1;
Emissions.MAW_rural2numerator(i)=Emissions.MAW_rural2denominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)>56.6 && MAW.averagespeedWindows(i)<=80 && i>Emissions.coldstartwindows
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_2(i)) %tol1minus=0.25
Emissions.MAW_rural2denominator(i)=1;
elseif MAW.CO2gkmWindows(i)>((1+MAW.tol1_def/100)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)<((1+0.5)*MAW.black_2(i)) %tol2plus=0.5
Emissions.MAW_rural2denominator(i)=(Emissions.MAW_index2(i)/(MAW.tol1_def-50))+ (50/(50-MAW.tol1_def));
elseif MAW.CO2gkmWindows(i)>((1-0.5)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)<((1-0.25)*MAW.black_2(i)) %tol2minus=0.5
Emissions.MAW_rural2denominator(i)=(Emissions.MAW_index2(i)/(50-MAW.tol1_def))+ (50/(50-MAW.tol1_def));
else
Emissions.MAW_rural2denominator(i)=0;
end
Emissions.MAW_rural2numerator(i)=Emissions.MAW_rural2denominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)<56.6 || MAW.averagespeedWindows(i)>80
Emissions.MAW_rural2numerator(i)=-100;
Emissions.MAW_rural2denominator(i)=-100;
end

if MAW.averagespeedWindows(i)>80  && i<=Emissions.coldstartwindows
Emissions.MAW_motorwaydenominator(i)=1;
Emissions.MAW_motorwaynumerator(i)=Emissions.MAW_motorwaydenominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)>80 && i>Emissions.coldstartwindows
if MAW.CO2gkmWindows(i)<((1+MAW.tol1_def/100)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)> ((1-0.25)*MAW.black_2(i)) %tol1minus=0.25
Emissions.MAW_motorwaydenominator(i)=1;
elseif MAW.CO2gkmWindows(i)>((1+MAW.tol1_def/100)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)<((1+0.5)*MAW.black_2(i)) %tol2plus=0.5
Emissions.MAW_motorwaydenominator(i)=(Emissions.MAW_index2(i)/(MAW.tol1_def-50))+ (50/(50-MAW.tol1_def));
elseif MAW.CO2gkmWindows(i)>((1-0.5)*MAW.black_2(i)) &&  MAW.CO2gkmWindows(i)<((1-0.25)*MAW.black_2(i)) %tol2minus=0.5
Emissions.MAW_motorwaydenominator(i)=(Emissions.MAW_index2(i)/(50-MAW.tol1_def))+ (50/(50-MAW.tol1_def));
else
Emissions.MAW_motorwaydenominator(i)=0;
end
Emissions.MAW_motorwaynumerator(i)=Emissions.MAW_motorwaydenominator(i)*MAW.NOxgkmWindows(i);
elseif MAW.averagespeedWindows(i)<80
Emissions.MAW_motorwaynumerator(i)=-100;
Emissions.MAW_motorwaydenominator(i)=-100;    
end

end

Emissions.MAW_urbannumerator=Emissions.MAW_urbannumerator(Emissions.MAW_urbannumerator>-100);
Emissions.MAW_urbandenominator=Emissions.MAW_urbandenominator(Emissions.MAW_urbandenominator>-100);
Emissions.MAW_rural1numerator=Emissions.MAW_rural1numerator(Emissions.MAW_rural1numerator>-100);
Emissions.MAW_rural1denominator=Emissions.MAW_rural1denominator(Emissions.MAW_rural1denominator>-100);
Emissions.MAW_rural2numerator=Emissions.MAW_rural2numerator(Emissions.MAW_rural2numerator>-100);
Emissions.MAW_rural2denominator=Emissions.MAW_rural2denominator(Emissions.MAW_rural2denominator>-100);
Emissions.MAW_motorwaynumerator=Emissions.MAW_motorwaynumerator(Emissions.MAW_motorwaynumerator>-100);
Emissions.MAW_motorwaydenominator=Emissions.MAW_motorwaydenominator(Emissions.MAW_motorwaydenominator>-100);

Emissions.MAW_urban= 1000*sum(Emissions.MAW_urbannumerator)/sum(Emissions.MAW_urbandenominator); %mg/km
Emissions.MAW_rural= 1000*(sum(Emissions.MAW_rural1numerator)+sum(Emissions.MAW_rural2numerator))/(sum(Emissions.MAW_rural1denominator)+sum(Emissions.MAW_rural2denominator)); %mg/km
Emissions.MAW_motorway= 1000*sum(Emissions.MAW_motorwaynumerator)/sum(Emissions.MAW_motorwaydenominator); %mg/km
Emissions.MAW_Total=0.34*Emissions.MAW_urban+0.33*Emissions.MAW_rural+0.33*Emissions.MAW_motorway; %mg/km

fprintf (REPORT,'\r\n');
fprintf (REPORT,'PACK 3: MAW NOx Emissions:\r\n');
fprintf (REPORT,'- Total: %6.2f mg/km \r\n',Emissions.MAW_Total);
fprintf (REPORT,'- Urban: %6.2f mg/km \r\n',Emissions.MAW_urban);

% app.MAWNOxtotalemissions3mgkmEditField.Value=Emissions.MAW_Total;
% app.MAWNOxurbanemissions3mgkmEditField.Value=Emissions.MAW_urban;

%% Raw emissions & Pack 4
Emissions.RAW_TOT_NOxCUMULATED=cumtrapz(INCAdata.time,Emissions.NOxmass); %g
Emissions.RAW_TOT_NOx=1000*Emissions.RAW_TOT_NOxCUMULATED(end)/distance.tot(end); %mg/km
Emissions.CO2gs=PB.CO2TOT/3600;
Emissions.RAW_TOT_CO2CUMULATED=cumtrapz(INCAdata.time,Emissions.CO2gs); %g
Emissions.RAW_TOT_CO2=1000*Emissions.RAW_TOT_CO2CUMULATED(end)/distance.tot(end); %mg/km

Emissions.RAW_urban_CO2(1)=0;
Emissions.RAW_urban_NOx(1)=0;
for i=2:length(INCAdata.IN_Vehicle_speed)
if INCAdata.IN_Vehicle_speed(i)<60
Emissions.RAW_urban_CO2(i)=Emissions.RAW_urban_CO2(i-1)+Emissions.CO2gs(i); %g
Emissions.RAW_urban_NOx(i)=Emissions.RAW_urban_NOx(i-1)+Emissions.NOxmass(i); %g
else
Emissions.RAW_urban_CO2(i)=Emissions.RAW_urban_CO2(i-1);
Emissions.RAW_urban_NOx(i)=Emissions.RAW_urban_NOx(i-1);
end
end
Emissions.RAW_urban_CO2_mgkm=1000*Emissions.RAW_urban_CO2(end)/distance.urban(end); %mg/km
Emissions.RAW_urban_NOx_mgkm=1000*Emissions.RAW_urban_NOx(end)/distance.urban(end); %mg/km

Emissions.RAW_CO2WLTP=Input.CO2_WLTP_gkm; %g/km
Emissions.RAW_CO2WLTP_urban=Input.CO2_WLTP_urban_gkm; %Honda (low & medium phase) (g/km)
Emissions.RAW_CO2ratio=Emissions.RAW_TOT_CO2/(1000*Emissions.RAW_CO2WLTP); 
Emissions.RAW_CO2ratio_urban=Emissions.RAW_urban_CO2_mgkm/(1000*Emissions.RAW_CO2WLTP_urban); 
Emissions.RAW_RFL1=1.30; %1.20
Emissions.RAW_RFL2=1.50; %1.25

if Emissions.RAW_CO2ratio<=Emissions.RAW_RFL1
Emissions.RAW_EvaluationFactor=1;
elseif Emissions.RAW_CO2ratio<=Emissions.RAW_RFL2 && Emissions.RAW_CO2ratio>Emissions.RAW_RFL1
Emissions.RAW_a1=(Emissions.RAW_RFL2-1)/((Emissions.RAW_RFL1-Emissions.RAW_RFL2)*Emissions.RAW_RFL2);
Emissions.RAW_b1=1-Emissions.RAW_a1*Emissions.RAW_RFL1;
Emissions.RAW_EvaluationFactor=(Emissions.RAW_CO2ratio*Emissions.RAW_a1)+Emissions.RAW_b1;
else
Emissions.RAW_EvaluationFactor=1/Emissions.RAW_CO2ratio;
end

if Emissions.RAW_CO2ratio_urban<=Emissions.RAW_RFL1
Emissions.RAW_EvaluationFactor_urban=1;
elseif Emissions.RAW_CO2ratio_urban<=Emissions.RAW_RFL2 && Emissions.RAW_CO2ratio_urban>Emissions.RAW_RFL1
Emissions.RAW_a1_urban=(Emissions.RAW_RFL2-1)/((Emissions.RAW_RFL1-Emissions.RAW_RFL2)*Emissions.RAW_RFL2);
Emissions.RAW_b1_urban=1-Emissions.RAW_a1_urban*Emissions.RAW_RFL1;
Emissions.RAW_EvaluationFactor_urban=(Emissions.RAW_CO2ratio_urban*Emissions.RAW_a1_urban)+Emissions.RAW_b1_urban;
else
Emissions.RAW_EvaluationFactor_urban=1/Emissions.RAW_CO2ratio_urban;
end

Emissions.RAW_TOT_NOx_PACK4=Emissions.RAW_TOT_NOx*Emissions.RAW_EvaluationFactor; %mg/km
Emissions.RAW_urban_NOx_PACK4=Emissions.RAW_urban_NOx_mgkm*Emissions.RAW_EvaluationFactor_urban;%mg/km

fprintf (REPORT,'\r\n');
fprintf (REPORT,'PACK 4:NOx Emissions:\r\n');
fprintf (REPORT,'- Total: %6.2f mg/km \r\n',Emissions.RAW_TOT_NOx_PACK4); 
fprintf (REPORT,'- Urban: %6.2f mg/km \r\n',Emissions.RAW_urban_NOx_PACK4); 

fprintf (REPORT,'\r\n');
fprintf (REPORT,'CO2 Raw emissions: %6.2f g/km \r\n', Emissions.RAW_TOT_CO2/1000);

% app.NOxtotalemissions4mgkmEditField.Value=Emissions.RAW_TOT_NOx_PACK4;
% app.NOxurbanemissions4mgkmEditField.Value=Emissions.RAW_urban_NOx_PACK4;

%% Close the report
fclose(REPORT);